<?php

//SMFChess Source File
//Chess.php

if (!defined('SMF'))
	die('Hacking attempt...');

//Tells the user where to go initially, and loads any info that the user might not have
function Chess()
{
	global $context, $txt, $scripturl, $options, $modSettings;
	
	$modSettings['defaultMaxMembers'] = 20;
	
	if(!isset($options['SMFChess_board'])&&!$context['user']['is_guest'])
		$options['SMFChess_board'] = '';
	
	if(!isset($options['SMFChess_effect'])){
		$options['SMFChess_dark'] = $modSettings['SMFChess_dark'];
		$options['SMFChess_light'] = $modSettings['SMFChess_light'];
		$options['SMFChess_border'] = $modSettings['SMFChess_border'];
		$options['SMFChess_text'] = $modSettings['SMFChess_text'];
		$options['SMFChess_highlight'] = $modSettings['SMFChess_highlight'];
		$options['SMFChess_default'] = true;
		$options['SMFChess_piece'] = '';
		$options['SMFChess_size'] = 0;
		$options['SMFChess_effect'] = -1;
	}
	
	if(!isset($options['SMFChess_log']))
		$options['SMFChess_log'] = $modSettings['SMFChessChat_log'];
	
	if(!isset($options['SMFChess_pm']))
		$options['SMFChess_pm'] = true;
	
	if(!isset($options['SMFChess_quickplay']))
		$options['SMFChess_quickplay'] = true;	
			
	loadLanguage('Chess');
	loadTemplate('Chess');
	
	isAllowedTo('chess_main');
	
	$context['template_layers'][] = 'chess';
	$context['page_index'] = '';
	
	if($modSettings['SMFChess_bar'] == 0)
		loadTemplate('ChessCustom');
	
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess',
		'name' => $txt['SMFChess'],
	);
	
	$context['sort_links'] = array();
	if(!empty($options['SMFChess_board']))
		$context['sort_links'][] = array('action' => 'board',
										'label' => $txt['SMFChess_labels']['board'].'['.$options['SMFChess_board'].']');
	if(allowedTo('chess_play'))
		$context['sort_links'][] = array('action' => 'challenge',
										'label' => $txt['SMFChess_labels']['challenge']);
	if(!$context['user']['is_guest'])		
		$context['sort_links'][] = array('action' => 'main',
										'label' => $txt['SMFChess_labels']['mypage']);
	$context['sort_links'][] = array('action' => 'current',
										'label' => $txt['SMFChess_labels']['current']);
	$context['sort_links'][] = array('action' => 'finished',
										'label' => $txt['SMFChess_labels']['finished']);
	$context['sort_links'][] = array('action' => 'leaderboard',
										'label' => $txt['SMFChess_labels']['leaderboard']);
	if(!$context['user']['is_guest'])		
		$context['sort_links'][] = array('action' => 'settings',
										'label' => $txt['SMFChess_labels']['settings']);
	
	$actions = array(
		'board' => 'SMFChessBoard',
		'challenge' => 'SMFChessChallenge',
		'main' => 'SMFChessMyPage',
		'current' => 'SMFChessCurrent',
		'finished' => 'SMFChessFinished',
		'leaderboard' => 'SMFChessLeaderboard',
		'settings' => 'SMFChessSettings',
	);

	if (!isset($_GET['sa'])){
		if($context['user']['is_guest'])
			$action = 'current';
		else
			$action = 'main';
	}else{
		$action = $_GET['sa'];
	}	
	
	if((isset($_POST['challengeForm']) || isset($_GET['join'])) && allowedTo('chess_play'))
		SMFChessChallengeForm();
	
	if(isset($_GET['id']))
		SMFChessBoard();
	elseif(isset($actions[$action]))
		$actions[$action]();
	else
		SMFChessCurrent();
}

//Returns gamestate
function State_to_Name($i) {
	global $txt;
	
	if(!isset($txt['SMFChess_status'][$i]))
		return $txt['SMFChess_status']['UNK'];
	return $txt['SMFChess_status'][$i];
} 

//Returns control msg			
function Control_to_Name($i) {
	global $context, $scripturl, $txt;
		switch ($i) {
			case 0	:	return "-";
            
			case 1	:	return ($context['SMFChess']['page']['yours'] ? sprintf($txt['SMFChess_control']['undo1'], $context['SMFChess'][$context['SMFChess']['page']['turnOpp']]['name']). ' <a href="javascript:void(0)" onclick="chessCommand(\'undo\');"><b><u>'.$txt['SMFChess_control']['accept'].'</u></b></a> '.$txt['SMFChess_control']['or'].' <a href="javascript:void(0)" onclick="chessCommand(\'reject\');"><b><u>'.$txt['SMFChess_control']['reject'].'</u></b></a>' : sprintf($txt['SMFChess_control']['undo2'], $context['SMFChess'][$context['SMFChess']['page']['turn']]['name']));
			
			case 2	:	return ($context['SMFChess']['page']['yours'] ? $txt['SMFChess_control']['notstarted1'] : $txt['SMFChess_control']['notstarted2']);
			
			case 3	:	return (($context['SMFChess']['page']['extra'] == $context['user']['id']) && (!empty($context['SMFChess']['page']['side'])) ? sprintf($txt['SMFChess_control']['draw1'], $context['SMFChess'][$context['SMFChess']['page']['turnOpp']]['name']). ' <a href="javascript:void(0)" onclick="chessCommand(\'draw\');"><b><u>'.$txt['SMFChess_control']['accept'].'</u></b></a> '.$txt['SMFChess_control']['or'].' <a href="javascript:void(0)" onclick="chessCommand(\'reject\');"><b><u>'.$txt['SMFChess_control']['reject'].'</u></b></a>' : sprintf($txt['SMFChess_control']['draw2'], $context['SMFChess'][$context['SMFChess']['page']['turn']]['name']) );
			case 4	:	return (($context['SMFChess']['page']['extra'] == $context['user']['id']) && (!empty($context['SMFChess']['page']['side'])) ? sprintf($txt['SMFChess_control']['resign1'], $context['SMFChess'][$context['SMFChess']['page']['turnOpp']]['name']).' <a href="javascript:void(0)" onclick="chessCommand(\'resign\');"><b><u>'.$txt['SMFChess_control']['accept'].'</u></b></a> '.$txt['SMFChess_control']['or'].' <a href="javascript:void(0)" onclick="chessCommand(\'reject\');"><b><u>'.$txt['SMFChess_control']['reject'].'</u></b></a>' : sprintf($txt['SMFChess_control']['resign2'], $context['SMFChess'][$context['SMFChess']['page']['turn']]['name']) );
            default	:	return $txt['SMFChess_control']['unk'];
		}
		
} 


// Recursive function to retrieve piece directories, based on the one for avatar files
// Thanks for that SMF
function getPieces($directory)
{
	global $txt, $settings, $options;
	
	$piece_dir = $settings['default_theme_dir'].'/SMFChess/pieces';
	
	$result = array();

	// Open the directory..
	$dir = dir($piece_dir . (!empty($directory) ? '/' : '') . $directory);
	$dirs = array();

	if (!$dir)
		return array();

	while ($line = $dir->read())
	{
		if (in_array($line, array('.', '..', 'blank.gif', 'index.php')))
			continue;

		if (is_dir($piece_dir . '/' . $directory . (!empty($directory) ? '/' : '') . $line))
			$dirs[] = $line;
	}
	$dir->close();

	// Sort the results...
	natcasesort($dirs);
	
	if(!isset($options['SMFChess_piece']))
		$options['SMFChess_piece'] = '';
	
	$result[] = array(
		'filename' => '',
		'checked' => empty($options['SMFChess_piece'])? true : false,
		'name' => $txt['SMFChess_labels']['forumdefault'],
		'is_dir' => true
	);
	
	foreach ($dirs as $line)
	{
		$result[] = array(
			'filename' => htmlspecialchars($line),
			'checked' => $options['SMFChess_piece'] == htmlspecialchars($line),
			'name' => htmlspecialchars(str_replace('_', ' ', $line)),
			'is_dir' => true
		);
	}

	return $result;
}

//Load opponent info, not sure why I use this
function getOpponent($getId)
{
	global $memberContext, $context;
	
	loadMemberContext($getId);
	
	$context['SMFChess']['member_data'] = $memberContext[$getId];
}

//Handles PM's
function chessPM($type, $sendId, $boardId, $pmMsg = '')
{
	global $scripturl, $context, $sourcedir, $settings, $func, $txt;
	
	include_once($sourcedir . '/Subs-Post.php');
	
	if(in_array($type, array('challenge', 'QuickmatchJoined'))){
		// Who the IM will come from		 
		$pmfrom = array(
			'id' => $context['user']['id'],
			'name' => $context['user']['name'],
			'username' => $context['user']['username']
		);
		
		// Who the IM is going to
		$pmto = array(
			'to' => array($sendId),
			'bcc' => array()
		);
		
		$pmMsg = $func['htmlspecialchars']($pmMsg, ENT_QUOTES);
										
		// The subject of the message
		$subject = $txt['SMFChess_pm'][$type.'_sub'];
		// The actual message contents
		$message = (!empty($pmMsg)?$pmMsg.'
':'').$txt['SMFChess_pm']['followlink'].$scripturl.'?action=chess;id='.$boardId;
		// Now, send!
		sendpm($pmto, $subject, $message, 0, $pmfrom);
	}
	//Remind User
	elseif(in_array($type, array('remind'))){
		// Who the IM will come from		 
		$pmfrom = array(
			'id' => $context['user']['id'],
			'name' => $context['user']['name'],
			'username' => $context['user']['username']
		);
		
		// Who the IM is going to
		$pmto = array(
			'to' => array($sendId),
			'bcc' => array()
		);

		// The subject of the message
		$subject = $txt['SMFChess_pm'][$type.'_sub'];
		// The actual message contents
		$message = $txt['SMFChess_pm'][$type.'_msg'].$txt['SMFChess_pm']['followlink'].$scripturl.'?action=chess;id='.$boardId;
		// Now, send!
		sendpm($pmto, $subject, $message, 0, $pmfrom);
	}		
}

//After the Challenge Form
//Reason for it to be here, is just incase user is joining, and I can pass them right through
function SMFChessChallengeForm()
{
	global $db_prefix, $context, $sourcedir, $settings, $func, $scripturl, $txt, $modSettings;
	
	if(!isset($_POST['ChallengeMsg']))
		$_POST['ChallengeMsg'] = '';
		
	if(isset($_POST['challengeuser']))
	{
		$_POST['challengeuser'] = (int) $_POST['challengeuser'];
		$getUser = db_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}members
			WHERE ID_MEMBER = '{$_POST['challengeuser']}'
			LIMIT 1", __FILE__, __LINE__);
		list($userID) = mysql_fetch_row($getUser);
		mysql_free_result($getUser);
			
		if(!empty($userID)){
			if($userID != $context['user']['id']){
				if($_POST['ChallengeVariation'] == 3){
					srand(time());
					$fischerArray =  file($settings['default_theme_dir'].'/SMFChess/fischer'.rand(0, 9).'.txt');
					if($fischerArray){
						$keyTemp = array_rand($fischerArray, 1);
						$fenTemp = $fischerArray[$keyTemp];
						unset($fischerArray);
						unset($keyTemp);
					}else
						$fenTemp = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -';
					
				}else
					$fenTemp = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -';
				
				$_POST['ChallengeMoveClock'] = (int)$_POST['ChallengeMoveClock'];
				$_POST['ChallengeVariation'] = (int)$_POST['ChallengeVariation'];
				
				db_query("INSERT INTO {$db_prefix}chess SET boarddata='{$fenTemp} 0 1', white='{$userID}', black='{$context['user']['id']}', status='0', move='0', created='".time()."', updated='0', control='2', extra='{$userID}', moveclock='{$_POST['ChallengeMoveClock']}', variation='{$_POST['ChallengeVariation']}', movetime = '".time()."'" , __FILE__, __LINE__);
								
				$newId = db_insert_id();
				
				//Insert Move
				db_query("INSERT INTO {$db_prefix}chess_move SET id_chess='{$newId}', ID_MEMBER='{$context['user']['id']}', move='0', status='0', move_info='---------', boarddata='{$fenTemp} 0 1', turn='b'" , __FILE__, __LINE__);		
				
				//Add rules to msg
				$_POST['ChallengeMsg'] = $_POST['ChallengeMsg'].'

'.$txt['SMFChess_Challenge']['variant'].': '.$txt['SMFChess_variation'][$_POST['ChallengeVariation']] .
										($_POST['ChallengeMoveClock'] ? '
'.$txt['SMFChess_labels']['moveclock'].': '.$txt['SMFChess_moveclock'][$_POST['ChallengeMoveClock']] : '');
				
				chessPM('challenge', $userID, $newId, $_POST['ChallengeMsg']);
				unset($fenTemp);
				$context['SMFChess']['error'] = $txt['SMFChess_errors']['challengesuccess'];
			}else
				$context['SMFChess']['error'] = $txt['SMFChess_errors']['challengeself'];
		}else
			$context['SMFChess']['error'] = $txt['SMFChess_errors']['challengenouser'];

	//Quickmatch
	}else{
		if(isset($_GET['join'])){
			
			checkSession('get');
			
			$modSettings['SMFChess_cjoinlimit'] = (int) (!isset($modSettings['SMFChess_cjoinlimit']) ? 1 : $modSettings['SMFChess_cjoinlimit']);
			
			$request = db_query("
				SELECT id_chess
				FROM {$db_prefix}chess
				WHERE white = {$context['user']['id']} AND status = 0 AND DAYOFYEAR(CURDATE()) - DAYOFYEAR(FROM_UNIXTIME(created)) = 0
				LIMIT {$modSettings['SMFChess_cjoinlimit']}", __FILE__, __LINE__);
				 
			if(mysql_num_rows($request) < $modSettings['SMFChess_cjoinlimit']){
				mysql_free_result($request);	
								
				$_GET['join'] = (int)$_GET['join'];
				
				$request = db_query("
					SELECT id_chess, black
					FROM {$db_prefix}chess
					WHERE white = 0 AND status = 0 AND black != '{$context['user']['id']}' AND id_chess = '{$_GET['join']}'
					LIMIT 1", __FILE__, __LINE__);
				if(mysql_num_rows($request) == 0){
					mysql_free_result($request);
					$context['SMFChess']['error'] = $txt['SMFChess_errors']['quickmatchnotfound'];
				}else{
					list($boardId, $oppId) = mysql_fetch_row($request);
					mysql_free_result($request);
					
					db_query("UPDATE {$db_prefix}chess
						SET white = '{$context['user']['id']}', created = '".time()."', updated='".time()."', status = 0, control = 0, extra='{$context['user']['id']}', movetime = '".time()."'
						WHERE id_chess = '$boardId'
						LIMIT 1", __FILE__, __LINE__);
						
					chessPM('QuickmatchJoined', $oppId, $boardId);
					
					$_GET['id'] = $boardId;
					
				}
			}else{
				mysql_free_result($request);
				$context['SMFChess']['error'] = sprintf($txt['SMFChess_errors']['joinoneperday'], $modSettings['SMFChess_cjoinlimit']);	
			}
		}else{

			$modSettings['SMFChess_cquicklimit'] = (int) (!isset($modSettings['SMFChess_cquicklimit']) ? 1 : $modSettings['SMFChess_cquicklimit']);
			
			$request = db_query("
				SELECT id_chess, created
				FROM {$db_prefix}chess
				WHERE white = 0 AND status = 0 AND black = {$context['user']['id']} AND DAYOFYEAR(CURDATE()) - DAYOFYEAR(FROM_UNIXTIME(created)) = 0
				LIMIT {$modSettings['SMFChess_cquicklimit']}", __FILE__, __LINE__);

			if(mysql_num_rows($request) < $modSettings['SMFChess_cquicklimit']){
				mysql_free_result($request);
					
				$context['SMFChess']['error'] = $txt['SMFChess_errors']['quickmatchcreated'];
					
				if($_POST['ChallengeVariation'] == 3){
					srand(time());
					$fischerArray =  file($settings['default_theme_dir'].'/SMFChess/fischer'.rand(0, 9).'.txt');
					if($fischerArray){
						$keyTemp = array_rand($fischerArray, 1);
						$fenTemp = $fischerArray[$keyTemp];
						unset($fischerArray);
						unset($keyTemp);							
					}else
						$fenTemp = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -';
						
				}else
					$fenTemp = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -';
				
				$_POST['ChallengeMoveClock'] = (int)$_POST['ChallengeMoveClock'];
				$_POST['ChallengeVariation'] = (int)$_POST['ChallengeVariation'];
						
				db_query("INSERT INTO {$db_prefix}chess SET boarddata='{$fenTemp} 0 1', white='0', black='{$context['user']['id']}', status='0', move='0', created='".time()."', updated='0', control='2', extra='0', moveclock='{$_POST['ChallengeMoveClock']}', variation='{$_POST['ChallengeVariation']}'" , __FILE__, __LINE__);
				$newId = db_insert_id();
					
				//Insert Move
				db_query("INSERT INTO {$db_prefix}chess_move SET id_chess='{$newId}', ID_MEMBER='{$context['user']['id']}', move='0', status='0', move_info='---------', boarddata='{$fenTemp} 0 1', turn='b'" , __FILE__, __LINE__);
						
				if(!empty($_POST['ChallengeMsg'])){
					require_once($sourcedir . '/Subs-Post.php');
					$_POST['ChallengeMsg'] = $func['htmlspecialchars']($_POST['ChallengeMsg'], ENT_QUOTES);
													
					$_POST['ChallengeMsg'] = str_replace(array("[list]","[center]","[left]","[right]"),"",$_POST['ChallengeMsg']);
					preparsecode($_POST['message']);
					$_POST['ChallengeMsg'] = parse_bbc($_POST['ChallengeMsg']);
					censorText($_POST['ChallengeMsg']);
							
					//Add profile link
					$_POST['ChallengeMsg'] = '<a href="'.$scripturl.'?action=profile;u='.$context['user']['id'].'">'.$context['user']['name'].'</a> : '.$_POST['ChallengeMsg'];
							
					db_query("INSERT INTO {$db_prefix}chess_chat 
					SET id_chess='{$newId}',  timestamp='".time()."', text='{$_POST['ChallengeMsg']}', id_member='{$context['user']['id']}'" , __FILE__, __LINE__);			
				}
			//Found one
			}else{
				$context['SMFChess']['error'] = sprintf($txt['SMFChess_errors']['createoneperday'], $modSettings['SMFChess_cquicklimit']);	
				mysql_free_result($request);
			}
		}
	}
}

//Loads the Chess Board
//OMG this is an ungly function, but its easy to add to...well easy for me
//So i've left it messy, feel free to insult me on it if you ever take a look
//but please dont, and be gentle
function SMFChessBoard()
{
	global $db_prefix, $context, $options, $modSettings, $scripturl, $user_info, $txt, $sourcedir, $memberContext, $settings;
	
	if(!isset($_GET['id'])){
		if(!empty($options['SMFChess_board']))
			$_GET['id'] = $options['SMFChess_board'];
		else
			$_GET['id'] = 0;
	}
	
	$_GET['id'] = (int)$_GET['id'];
		
	$context['dhtmlInfo'] = "";
	$context['dhtmlIEunprettyfix'] = "";
	$context['SMFChess']['board'] = array();
	$context['SMFChess']['board']['SMFChess_dark'] = '#'.( $options['SMFChess_default']? $modSettings['SMFChess_dark'] : $options['SMFChess_dark']);
	$context['SMFChess']['board']['SMFChess_light'] = '#'.( $options['SMFChess_default']? $modSettings['SMFChess_light'] : $options['SMFChess_light']);
	$context['SMFChess']['board']['SMFChess_border'] = '#'.( $options['SMFChess_default']? $modSettings['SMFChess_border'] : $options['SMFChess_border']);
	$context['SMFChess']['board']['SMFChess_text'] = '#'.( $options['SMFChess_default']? $modSettings['SMFChess_text'] : $options['SMFChess_text']);
	$context['SMFChess']['board']['SMFChess_highlight'] = '#'. ($options['SMFChess_default']? $modSettings['SMFChess_highlight'] : $options['SMFChess_highlight']);
	$context['SMFChess']['board']['SMFChess_piece'] = empty($options['SMFChess_piece'])? $modSettings['SMFChess_piece']: $options['SMFChess_piece'];
	
	$context['SMFChess']['board']['filetype'] = file_exists($settings['default_theme_dir'].'/SMFChess/pieces/' . $context['SMFChess']['board']['SMFChess_piece'] . '/white_pawn.png') ? '.png' : '.gif' ;
	$context['SMFChessXml']['board']['pieceInfo'] = getimagesize($settings['default_theme_dir'].'/SMFChess/pieces/' . $context['SMFChess']['board']['SMFChess_piece'] . '/white_pawn'.$context['SMFChess']['board']['filetype']);
	
	$context['SMFChess']['board']['SMFChess_effect'] = ($options['SMFChess_effect'] < 0) ? $modSettings['SMFChess_effect']: $options['SMFChess_effect'];
	
	$context['SMFChess']['board']['SMFChess_size'] = ($modSettings['SMFChess_size'] ? $modSettings['SMFChess_size'] : $context['SMFChessXml']['board']['pieceInfo'][0]) + $options['SMFChess_size'];
		
	$result = db_query("
		SELECT chess.*, mw.realName as whiteName, mb.realName as blackName, chat.text AS notepad
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		LEFT JOIN {$db_prefix}chess_chat AS chat ON (chat.type = 2 AND chat.id_member = {$context['user']['id']} AND chat.id_chess = chess.id_chess)
		WHERE chess.id_chess = '{$_GET['id']}'
		ORDER BY chess.id_chess
		LIMIT 1
		", __FILE__, __LINE__);
	$context['SMFChess']['page'] = array();
	if(mysql_num_rows($result) == 0){
		mysql_free_result($result);
		$context['SMFChess']['error'] = $txt['SMFChess_errors']['nomatch'];
		$context['SMFChess']['page']['id_chess'] = 0;
		if(isset($options['SMFChess_board'])){
			if($_GET['id'] == $options['SMFChess_board']){
				$_POST['options']['SMFChess_board'] = '';
				include_once($sourcedir . '/Profile.php');
				makeThemeChanges($context['user']['id'], $settings['theme_id']);
			}
		}
	}else{
		$context['SMFChess']['page'] = mysql_fetch_assoc($result);
		mysql_free_result($result);
		
		$context['SMFChess']['page']['created'] = date("d M `y", $context['SMFChess']['page']['created']+(($user_info['time_offset'] + $modSettings['time_offset'])*3600));
		$context['SMFChess']['page']['timestamp'] = $context['SMFChess']['page']['updated'];

		if($context['SMFChess']['page']['updated'] != 0)
			$context['SMFChess']['page']['updated'] = date("d M g:ia", $context['SMFChess']['page']['updated']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		else
			$context['SMFChess']['page']['updated'] = "-";
			
		$context['SMFChess']['page']['turn'] = (strstr($context['SMFChess']['page']['boarddata'], "w")?$context['SMFChess']['page']['white']:$context['SMFChess']['page']['black']);
		$context['SMFChess']['page']['turnOpp'] = (strstr($context['SMFChess']['page']['boarddata'], "w")?$context['SMFChess']['page']['black']:$context['SMFChess']['page']['white']);
		$context['SMFChess']['page']['oppId'] = $context['user']['id'] == $context['SMFChess']['page']['turn'] ? $context['SMFChess']['page']['turnOpp'] : $context['SMFChess']['page']['turn'] ;
		if($context['SMFChess']['page']['status'] > 2){
			if($context['SMFChess']['page']['status'] == 5)
				$context['SMFChess']['page']['turn'] = $context['SMFChess']['page']['extra'];
			else
				$context['SMFChess']['page']['turn'] = $context['SMFChess']['page']['turnOpp'];
		}
			
		$context['SMFChess']['page']['yours'] = ($context['user']['id'] == $context['SMFChess']['page']['turn']);
		$context['SMFChess']['page']['side'] = ($context['SMFChess']['page']['white'] == $context['user']['id'] ? 'w' : ($context['user']['id'] == $context['SMFChess']['page']['black'] ? 'b' : '')); 
			
		loadMemberData(array($context['SMFChess']['page']['white'], $context['SMFChess']['page']['black']));
		loadMemberContext($context['SMFChess']['page']['white']);
		loadMemberContext($context['SMFChess']['page']['black']);
		$context['SMFChess'][$context['SMFChess']['page']['white']] = $memberContext[$context['SMFChess']['page']['white']];
		$context['SMFChess'][$context['SMFChess']['page']['black']] = $memberContext[$context['SMFChess']['page']['black']];
			
		$context['SMFChess'][$context['SMFChess']['page']['white']]['can_view_profile'] = allowedTo('profile_view_any') || (($context['SMFChess']['page']['white'] == $context['user']['id']) && allowedTo('profile_view_own'));
		$context['SMFChess'][$context['SMFChess']['page']['black']]['can_view_profile'] = allowedTo('profile_view_any') || (($context['SMFChess']['page']['black'] == $context['user']['id']) && allowedTo('profile_view_own'));
		$context['can_send_pm'] = allowedTo('pm_send');
			
		include_once($sourcedir . '/ChessFunctions.php');

		set_FEN($context['SMFChess']['page']['boarddata']);
		
		if(($context['SMFChess']['page']['variation'] == 1)&&($context['SMFChess']['page']['status'] < 2)){
			set_darkchess(($context['SMFChess']['page']['black'] == $context['user']['id'] ? -1 : ($context['SMFChess']['page']['white'] == $context['user']['id'] ? 1 :0)));
		}	
		
		$context['SMFChess']['page']['captured'] = findCaptured($context['SMFChess']['page']['boarddata']);
		$context['SMFChess']['page']['statusName'] = State_to_Name($context['SMFChess']['page']['status']);
		$context['SMFChess']['displayControl'] = ((!empty($context['SMFChess']['page']['side']))||allowedTo('chess_admin'))? true : false ;
		if($modSettings['SMFChessChat_enabled']){							
			switch($modSettings['SMFChessChat_see']){
				case 0	:	$context['SMFChess']['seeChat'] = true;
							break;
				case 1	:	$context['SMFChess']['seeChat'] = !$context['user']['is_guest'];
							break;
				case 2	:	$context['SMFChess']['seeChat'] = ($context['SMFChess']['page']['white'] == $context['user']['id'])||($context['SMFChess']['page']['black'] == $context['user']['id'])||allowedTo('chess_admin');
							break;
				default	:	$context['SMFChess']['seeChat'] = false;
			}
	
			switch($modSettings['SMFChessChat_who']){
				case 1	:	$context['SMFChess']['allowChat'] = (!$context['user']['is_guest']) && $context['SMFChess']['seeChat'];
							break;
				case 2	:	$context['SMFChess']['allowChat'] = (($context['SMFChess']['page']['white'] == $context['user']['id'])||($context['SMFChess']['page']['black'] == $context['user']['id'])||allowedTo('chess_admin')) && $context['SMFChess']['seeChat'];
							break;
				default	:	$modSettings['SMFChessChat_who'] = false;
			}
		}else{
			$context['SMFChess']['seeChat'] = false;
			$context['SMFChess']['allowChat'] = false;
		}
	
		$context['SMFChess']['message'] = '<b>'.Control_to_Name($context['SMFChess']['page']['control']).'</b>';
		
		
		//Move Clock
		if($context['SMFChess']['page']['moveclock']){
			if(($context['SMFChess']['page']['status'] == 0)||($context['SMFChess']['page']['status'] > 2))
				$context['SMFChess']['page']['moveTimeleft'] = DurationtoString($context['SMFChess']['page']['moveclock']);
			else{
				$context['SMFChess']['page']['moveclock'] = $context['SMFChess']['page']['moveclock'] - (time() - $context['SMFChess']['page']['movetime']);
				$context['SMFChess']['page']['moveclock'] = ($context['SMFChess']['page']['moveclock'] < 0) ? 0 : $context['SMFChess']['page']['moveclock'];
				
				if(($context['SMFChess']['page']['moveclock'] == 0) && (!empty($context['SMFChess']['page']['side'])) && (!$context['SMFChess']['page']['yours']) && (!$context['SMFChess']['page']['control'])){
					$context['SMFChess']['message'] = '<b>'.$txt['SMFChess_control']['moveexpired'].' '.$txt['SMFChess_control']['click'].' <a href="javascript:void(0)" onclick="if(confirm(\''.$txt['SMFChess_javascript']['yousure'].'\')){chessCommand(\'clock_accept_win\');}"><u>'.$txt['SMFChess_control']['here'].'</u></a> '.$txt['SMFChess_control']['acceptwin'].'</b>';
				}
				
				$context['SMFChess']['page']['moveTimeleft'] = DurationtoString($context['SMFChess']['page']['moveclock']);
				if($context['SMFChess']['page']['moveclock'] < 3600)
					$context['SMFChess']['page']['moveTimeleft'] = '<span class="meaction">'.$context['SMFChess']['page']['moveTimeleft'].'</span>';
			}
		}else
			$context['SMFChess']['page']['moveTimeleft'] = '-';
			
		//Black Below
		if($context['user']['id'] == $context['SMFChess']['page']['white'])
			$context['SMFChess']['page']['blackBelow'] = false;
		elseif($context['user']['id'] == $context['SMFChess']['page']['black'])
			$context['SMFChess']['page']['blackBelow'] = true;
		else
			$context['SMFChess']['page']['blackBelow'] = !strstr($context['SMFChess']['page']['boarddata'], "w");
		
		if(isset($_GET['switch']))
			$context['SMFChess']['page']['blackBelow'] = !$context['SMFChess']['page']['blackBelow'];
			
		//Move History
		$result = db_query("
			SELECT *
			FROM {$db_prefix}chess_move
			WHERE id_chess = '{$context['SMFChess']['page']['id_chess']}'".(($context['SMFChess']['page']['variation'] == 1)&&($context['SMFChess']['page']['status'] < 2) ? " AND (id_member = {$context['user']['id']} OR move = 0)" : "")."
			ORDER BY id_move DESC
			".($context['SMFChess']['page']['status'] < 3 ? "LIMIT 8" : "" ) ."", __FILE__, __LINE__);

		$context['SMFChess']['history'] = array();

		while ($row = mysql_fetch_assoc($result)){
			$context['SMFChess']['history'][] = $row;
		}
		mysql_free_result($result);
		
	}
		
	if(isset($_GET['default']) && !$context['user']['is_guest']){
		$_POST['options']['SMFChess_board'] = $_GET['id'];
		include_once($sourcedir . '/Profile.php');
		makeThemeChanges($context['user']['id'], $settings['theme_id']);
		$options['SMFChess_board'] = $_GET['id'];
	}
	
	$context['html_headers'] .= '
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/wz_dragdrop/wz_dragdrop.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/lib/prototype.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/src/scriptaculous.js?load=effects,controls"></script>';
	if($context['SMFChess']['seeChat']){
	$context['html_headers'] .= '
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/SMFChess.css">';
	}
	if(empty($context['SMFChess']['error'])){
	$context['html_headers'] .= '
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/SMFChess.js"></script>
			<script type="text/javascript">
			<!--
			var spacer = "'.$settings['default_theme_url'].'/SMFChess/wz_dragdrop/transparentpixel'.$context['SMFChess']['board']['filetype'].'";
			var boardId = "'.$context['SMFChess']['page']['id_chess'].'";
			
			var	cur_session_id = "'.$context['session_id'].'";
			var timestampOld = "'. ($context['SMFChess']['page']['timestamp']).'";
			
			var pieceLoc = "'.$settings['default_theme_url'].'/SMFChess/pieces/'.$context['SMFChess']['board']['SMFChess_piece'].'/";
			var blankLoc = "'.$settings['default_theme_url'].'/SMFChess/pieces/blank'.$context['SMFChess']['board']['filetype'].'";
			var loadingLoc = "'.$settings['default_theme_url'].'/SMFChess/images/loading.gif";
			var mySide = "'.($context['SMFChess']['page']['status'] < 3 ? $context['SMFChess']['page']['side'] : '' ).'";
			var canChat = '.($context['SMFChess']['allowChat'] ? 'true' : 'false').';
			var quickplay = '.($options['SMFChess_quickplay'] ? 'true' : 'false').';
			var pieceFileType = "'.$context['SMFChess']['board']['filetype'].'";
			
			var updateInterval = '.$modSettings['SMFChess_update'].'000;
			var updateIntervalChat = '.$modSettings['SMFChessChat_update'].'000;
			
			var chessTimeoutLimit = '. ((60 * $modSettings['SMFChess_timeout'])/$modSettings['SMFChess_update']).';
			var chessChatTimeoutLimit = '. ((60 * $modSettings['SMFChessChat_timeout'])/$modSettings['SMFChessChat_update']).';
			
			var chessTimeoutText = \''.$txt['SMFChess_javascript']['timeout_board'].' <a href="javascript:void(0)" onclick="timestampOld = 0;chessTimeout = 0;checkUpdate();">'.$txt['SMFChess_javascript']['reenable'].'</a>\';
			var chessChatTimeoutText = \''.$txt['SMFChess_javascript']['timeout_chat'].' <a href="javascript:void(0)" onclick="chesschat_total = -1;chessChatTimeout=0;checkUpdateChat();">'.$txt['SMFChess_javascript']['reenable'].'</a>\';
			
			var chessChatButSend = \''.$txt['SMFChess_Board']['chat_send'].'\';
			var chessChatButChat = \''.$txt['SMFChess_Board']['chatbutton'].'\';
			
			var txtpawnPromotion = \''.$txt['SMFChess_javascript']['promotion'].'\';
			var txtwouldcastle = \''.$txt['SMFChess_javascript']['wouldcastle'].'\';
			var txtyes = \''.$txt['SMFChess_javascript']['yes'].'\';
			var txtor = \''.$txt['SMFChess_control']['or'].'\';
			var txtno = \''.$txt['SMFChess_javascript']['no'].'\';
			var txtaddmove = \''.$txt['SMFChess_javascript']['addmove'].'\';
			
			var effectType = '.$context['SMFChess']['board']['SMFChess_effect'].';
			var effectHighlight = new Array("'.$context['SMFChess']['board']['SMFChess_dark'].'", "'.$context['SMFChess']['board']['SMFChess_light'].'", "'.$context['SMFChess']['board']['SMFChess_highlight'].'");
			
			var historyType = '.($context['SMFChess']['page']['status'] < 3 ? 'true':'false').';
			
			var is_disabled = true;
			
			window.onload = function(){
				'.($context['SMFChess']['page']['status'] < 3 ? 'clearTimer = setTimeout("checkUpdate()", updateInterval );':'').'
				'.($context['SMFChess']['seeChat']?'checkUpdateChat();':'').'
			}
			//-->
			</script>';
	}
	
	
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess;id='.$_GET['id'],
		'name' => $txt['SMFChess_labels']['board'],
	); 

	$context['SMFChess']['do'] = 'board';
	$context['page_title'] = $txt['SMFChess'].' - '.$txt['SMFChess_labels']['board'].' '.$_GET['id'];
	$context['sub_template'] = 'board';
}

//Loads any neccessary info for the challenge page
function SMFChessChallenge()
{
	global $context, $txt, $scripturl, $db_prefix, $modSettings, $user_info, $user_settings, $settings;
	
	isAllowedTo('chess_play');
		
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess;sa=challenge',
		'name' => $txt['SMFChess_labels']['challenge'],
	); 

	$result = db_query("
		SELECT chess.id_chess, chess.black, chess.created, chess.moveclock, chess.variation, mb.chess_elo as oppElo, cc.text,
		CASE chess.boarddata WHEN 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1'
		THEN '0' ELSE '1' END AS is_chess960
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		LEFT JOIN {$db_prefix}chess_chat AS cc ON (chess.id_chess = cc.id_chess)
		WHERE chess.status = 0 AND chess.white = 0
		ORDER BY chess.created ASC
		LIMIT 20", __FILE__, __LINE__);
	
	$context['SMFChess']['quickmatches'] = array();
	$opponents = array();
	
	while ($row = mysql_fetch_assoc($result)){
		$row['created'] = date("d M `y", $row['created']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		$row['moveclock'] = $row['moveclock'] ? $txt['SMFChess_moveclock'][$row['moveclock']] : '-';
		$row['oppElo'] = $row['oppElo'].' ('.(($row['oppElo'] - $user_settings['chess_elo']) > 0 ? '+' : '').($row['oppElo'] - $user_settings['chess_elo']).')';
		$context['SMFChess']['quickmatches'][] = $row;
		$opponents[] =  $row['black'];
	}
	mysql_free_result($result);
	
	$opponents = array_unique($opponents);
	
	if(!empty($opponents))
		loadMemberData($opponents);
	
	//Auto Challenger User
	if(isset($_GET['cUser'])){
	
		$_GET['cUser'] = (int) $_GET['cUser'];
		
		$result = db_query("
		SELECT ID_MEMBER, realName
		FROM {$db_prefix}members
		WHERE ID_MEMBER = {$_GET['cUser']} AND ID_MEMBER != {$context['user']['id']}
		LIMIT 1", __FILE__, __LINE__);
		
		if(mysql_num_rows($result) > 0){
			$context['SMFChess']['cUser'] = mysql_fetch_row($result);
		}else
			$context['SMFChess']['cUser'] = false;
		
		mysql_free_result($result);
		
	}else
		$context['SMFChess']['cUser'] = false;
	
	$context['html_headers'] .= '
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/lib/prototype.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/src/scriptaculous.js?load=effects,controls"></script>
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/SMFChess_challenge.css">
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/SMFChess_challenge.js"></script>';
	
	$context['SMFChess']['do'] = 'challenge';
	$context['page_title'] = $txt['SMFChess'].' - '.$txt['SMFChess_labels']['challenge'];
	$context['sub_template'] = 'challenge';
}

//Loads any Mypage info
function SMFChessMyPage()
{
	global $db_prefix, $context, $options, $modSettings, $scripturl, $user_info, $txt, $sourcedir, $user_settings;
	
	is_not_guest($txt['SMFChess_errors']['is_not_guest']);

	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess',
		'name' => $txt['SMFChess_labels']['mypage'],
	); 
	$daysRemind = time()-(86400*$modSettings['SMFChess_cremind']);
	$daysCancel = time()-(86400*$modSettings['SMFChess_ccancel']);		
	if(isset($_GET['reject'])&&isset($_GET['sesc'])){
		$_GET['reject'] = (int) $_GET['reject'];		
		checkSession('get');
		db_query("
			DELETE FROM {$db_prefix}chess
			WHERE status = 0 AND white = {$context['user']['id']} AND id_chess = {$_GET['reject']}
			LIMIT 1", __FILE__, __LINE__);
	}
	
	if(isset($_GET['remind'])){
		$_GET['remind'] = (int) $_GET['remind'];
		checkSession('get');
		$result = db_query("
			SELECT id_chess, white, black
			FROM {$db_prefix}chess
			WHERE id_chess = '{$_GET['remind']}'
			AND (white = '{$context['user']['id']}' OR black = '{$context['user']['id']}')
			AND updated < '{$daysRemind}'
			LIMIT 1", __FILE__, __LINE__);
		if(mysql_num_rows($result) == 1){
			$row = mysql_fetch_assoc($result);
			mysql_free_result($result);
			$userID = $row['white'] == $context['user']['id'] ? $row['black'] : $row['white'];
			db_query("UPDATE {$db_prefix}chess
				SET updated='".time()."'
				WHERE id_chess='{$row['id_chess']}'
				LIMIT 1", __FILE__, __LINE__);	
			chessPM('remind', $userID, $row['id_chess']);
			$context['SMFChess']['error'] = $txt['SMFChess_errors']['reminder'];
		}else
			mysql_free_result($result);
	}
	elseif(isset($_GET['cancel'])){
		$_GET['cancel'] = (int) $_GET['cancel'];
		checkSession('get');
		$result = db_query("
			SELECT id_chess, white, black
			FROM {$db_prefix}chess
			WHERE id_chess = '{$_GET['cancel']}'
			AND black = '{$context['user']['id']}'
			AND created < '{$daysCancel}'
			AND status = 0
			LIMIT 1", __FILE__, __LINE__);
		if(mysql_num_rows($result) == 1){
			$row = mysql_fetch_assoc($result);
			mysql_free_result($result);
			db_query("DELETE FROM {$db_prefix}chess
			WHERE id_chess = '{$row['id_chess']}' AND black = '{$context['user']['id']}' AND created < '{$daysCancel}' AND status = 0
			LIMIT 1", __FILE__, __LINE__);
			$context['SMFChess']['error'] = $txt['SMFChess_errors']['challengecancel'];
		}else
			mysql_free_result($result);
	}
	
	$context['SMFChess']['mystats'] = array(
		'myElo' => $user_settings['chess_elo'],
		'myWins' => $user_settings['chess_w'],
		'myDraws' => $user_settings['chess_d'],
		'myLoses' => $user_settings['chess_l']);
	
	if($user_settings['chess_s'] > 1)
		$context['SMFChess']['mystats']['myWins'] .= '(+'.$user_settings['chess_s'].')';
	elseif($user_settings['chess_s'] < 1)
		$context['SMFChess']['mystats']['myLoses'] .= '(+'.(-1*$user_settings['chess_s']).')';
	
	//Get myRank
	if(($user_settings['chess_w'] > 0)||($user_settings['chess_d'] > 0)||($user_settings['chess_l'] > 0)){
		$result = db_query("
			SELECT count(*) as rank
			FROM {$db_prefix}members
			WHERE (chess_elo > {$user_settings['chess_elo']})
			AND ((chess_w > 0) OR (chess_d > 0) OR (chess_l > 0))", __FILE__, __LINE__);
		list($context['SMFChess']['mystats']['myRank']) = mysql_fetch_row($result);
		mysql_free_result($result);
		$context['SMFChess']['mystats']['myRank']++;
		$context['SMFChess']['mystats']['is_ranked'] = true;
	}else{
		$context['SMFChess']['mystats']['myRank'] = '-';
		$context['SMFChess']['mystats']['is_ranked'] = false;
	}
	
	//get my total Moves
	$result = db_query("
			SELECT count(*)
			FROM {$db_prefix}chess_move
			WHERE ID_MEMBER = {$context['user']['id']} AND move > 0", __FILE__, __LINE__);
	list($context['SMFChess']['mystats']['myMoves']) = mysql_fetch_row($result);
	mysql_free_result($result);
			
	$result = db_query("
		SELECT chess.id_chess, chess.white, chess.black, chess.status, chess.move, chess.created, chess.updated, chess.extra, chess.moveclock, chess.movetime, chess.variation, mw.realName as whiteName, mb.realName as blackName
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		WHERE chess.status < 3 AND (mw.ID_MEMBER = '{$context['user']['id']}' OR mb.ID_MEMBER = '{$context['user']['id']}')
		ORDER BY chess.extra = '{$context['user']['id']}' DESC, chess.updated ASC", __FILE__, __LINE__);
	
	$context['SMFChess']['mymatches'] = array();
	$opponents = array();
	
	while ($row = mysql_fetch_assoc($result)){
		$row['statusId'] = $row['status'];
		$row['status'] = State_to_Name($row['status']);
		$row['turnId'] = $row['extra'];
		$row['turnName'] = ($row['white'] == $row['extra']) ? $row['whiteName'] : $row['blackName'];
		$row['turnName'] = ($row['extra'] == $context['user']['id']) ? '<span class="meaction">'.$txt['SMFChess_labels']['yours'].'</span>' : $row['turnName'];
		if(($row['extra'] != $context['user']['id'])&&($row['updated'] < $daysRemind))
			$row['turnName'] .= '<br/><span class="meaction"><a href="'.$scripturl.'?action=chess;sa=main;remind='.$row['id_chess'].';sesc='.$context['session_id'].'">'.$txt['SMFChess_labels']['remind'].'</a></span>';
		$row['opponent'] = $row['white'] == $context['user']['id'] ? $row['blackName'] :$row['whiteName'] ;
		$row['oppId'] = $row['white'] == $context['user']['id'] ? $row['black'] : $row['white'];
		
		if(($row['statusId'] > 0)&&($row['updated'] > 0))
			$row['updated'] = date("d M g:ia", $row['updated']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		elseif(($row['statusId'] == 0)&&($row['extra'] == $context['user']['id']))
			$row['updated'] = '<a href="'.$scripturl.'?action=chess;id='.$row['id_chess'].'">'.$txt['SMFChess_labels']['accept'].'</a> <a href="'.$scripturl.'?action=chess;sa=main;reject='.$row['id_chess'].';sesc='.$context['session_id'].'">'.$txt['SMFChess_labels']['reject'].'</a>';
		elseif(($row['statusId'] == 0)&&($row['black'] == $context['user']['id'])&&($row['created'] < $daysCancel))
			$row['updated'] = '<a href="'.$scripturl.'?action=chess;sa=main;cancel='.$row['id_chess'].';sesc='.$context['session_id'].'">'.$txt['SMFChess_Challenge']['cancel'].'</a>';
		else{
			$row['updated'] = "-";
		}
		
		$row['created'] = date("d M `y", $row['created']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		
		//Move Clock
		if($row['moveclock']){
				if($row['statusId'] == 0){
					$row['moveTimeleft'] = $txt['SMFChess_moveclock'][$row['moveclock']];
				}else{
					$row['moveclock'] = $row['moveclock'] - (time() - $row['movetime']);
					$row['moveclock'] = ($row['moveclock'] < 0) ? 0 : $row['moveclock'];
					$row['moveTimeleft'] = DurationtoString($row['moveclock']);
					
					if($row['moveclock'] < 3600 )
						$row['moveTimeleft'] = '<span class="meaction">'.$row['moveTimeleft'].'</span>';
				}
		}else
			$row['moveTimeleft'] = '-';
		
		$opponents[] =  $row['oppId'];
		$context['SMFChess']['mymatches'][] = $row;
	}
	mysql_free_result($result);
		
	$result = db_query("
		SELECT chess.id_chess, chess.white, chess.black, chess.status, chess.extra, mw.realName as whiteName, mb.realName as blackName
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		WHERE chess.status > 2 AND (mw.ID_MEMBER = '{$context['user']['id']}' OR mb.ID_MEMBER = '{$context['user']['id']}')
		ORDER BY chess.updated DESC
		LIMIT 5", __FILE__, __LINE__);
	
	$context['SMFChess']['recent'] = array();
	
	while ($row = mysql_fetch_assoc($result)){
		$row['result'] = ($row['status'] == 4) ? $txt['SMFChess_labels']['d'] : (($row['extra'] == $context['user']['id']) ? $txt['SMFChess_labels']['w'] : $txt['SMFChess_labels']['l'] );
		$row['status'] = State_to_Name($row['status']);
		$row['opponent'] = $row['white'] == $context['user']['id'] ? $row['blackName'] :$row['whiteName'] ;
	
		$context['SMFChess']['recent'][] = $row;
	}
	mysql_free_result($result);
	
	$result = db_query("
		SELECT ID_MEMBER, realName, chess_elo
		FROM {$db_prefix}members
		WHERE (chess_w > 0) OR (chess_d > 0) OR (chess_l > 0)
		ORDER BY chess_elo DESC, chess_w DESC, chess_d DESC, chess_l DESC
		LIMIT 10", __FILE__, __LINE__);
	
	$context['SMFChess']['topplayers'] = array();
	$rank = 1;
	while ($row = mysql_fetch_assoc($result)){
		$row['rank'] = $rank;
		$context['SMFChess']['topplayers'][] = $row;
		$rank++;
	}
	mysql_free_result($result);
	
		
	$opponents = array_unique($opponents);
	
	if(!empty($opponents))
		loadMemberData($opponents);
			
	// Prepare News
	if(!empty($modSettings['SMFChess_news'])){
		include_once($sourcedir . '/Subs-Post.php');
		$context['SMFChess']['news'] = $modSettings['SMFChess_news'];
		preparsecode($context['SMFChess']['news']);
		$context['SMFChess']['news'] = parse_bbc($context['SMFChess']['news']);
		censorText($context['SMFChess']['news']);
	}else
		$context['SMFChess']['news'] = '';
			
	$context['SMFChess']['do'] = 'main';
	$context['page_title'] = $txt['SMFChess'].' - '.$txt['SMFChess_labels']['mypage'];
	$context['sub_template'] = 'main';
}

//Loads the current page
function SMFChessCurrent()
{
	global $db_prefix, $context, $options, $modSettings, $scripturl, $user_info, $txt, $settings;
	
	if(isset($_GET['delete'])&&isset($_GET['sesc'])&&(allowedTo('chess_admin'))){
		$_GET['delete'] = (int) $_GET['delete'];
		checkSession('get');
		db_query("
			DELETE FROM {$db_prefix}chess
			WHERE id_chess = {$_GET['delete']}
			LIMIT 1", __FILE__, __LINE__);
			
		db_query("
			DELETE FROM {$db_prefix}chess_move
			WHERE id_chess = {$_GET['delete']}", __FILE__, __LINE__);
			
		db_query("
			DELETE FROM {$db_prefix}chess_chat
			WHERE id_chess = {$_GET['delete']}", __FILE__, __LINE__);			
	}
		
	$context['SMFChess']['board']['SMFChess_piece'] = empty($options['SMFChess_piece'])? $modSettings['SMFChess_piece']: $options['SMFChess_piece'];
		
	if(!isset($_GET['start']))
		$context['SMFChess']['start'] = 0;
	else
		$context['SMFChess']['start'] = (int) $_GET['start'];
		
	$sort_methods = array(
		'updated' => 'chess.updated',
		'created' => 'chess.created',
		'status' => 'chess.status',
		'moves' => 'chess.move'
	);
		
	if (!isset($_GET['sort']) || !isset($sort_methods[$_GET['sort']])){
		$context['SMFChess']['sort_by'] = 'updated';
		$_GET['sort'] = 'chess.updated';
	}else{
		$context['SMFChess']['sort_by'] = $_GET['sort'];
		$_GET['sort'] = $sort_methods[$_GET['sort']];
	}
		
	if(!isset($_GET['filter'])){
		$_GET['filter'] = '';
		$context['SMFChess']['filter'] = '';
	}else
		$context['SMFChess']['filter'] = ';filter='.$_GET['filter'];
	
	$context['SMFChess']['sort_direction'] = isset($_GET['asc']) ? 'up' : 'down';
		
	$result = db_query("
		SELECT chess.id_chess, chess.white, chess.black, chess.status, chess.move, chess.created, chess.updated, chess.extra, chess.variation, mw.realName as whiteName, mb.realName as blackName
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		WHERE chess.status < 3 AND chess.status > 0 " . (!empty($_GET['filter']) ? "AND (chess.white = '{$_GET['filter']}' OR chess.black = '{$_GET['filter']}')" : ""). "
		ORDER BY {$_GET['sort']} " . (isset($_GET['asc']) ? 'ASC' : 'DESC') . "
		LIMIT {$context['SMFChess']['start']}, {$modSettings['defaultMaxMembers']}", __FILE__, __LINE__);
	
	$context['SMFChess']['page'] = array();
	
	while ($row = mysql_fetch_assoc($result)){
		$row['created'] = date("d M `y", $row['created']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		if($row['updated'] != 0)
			$row['updated'] = date("d M g:ia", $row['updated']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		else
			$row['updated'] = "-";
			
		$row['status'] = State_to_Name($row['status']);
		$row['turn'] = $row['extra'];
		$row['turnC'] = $row['black'] == $row['extra'] ? 'black' : 'white' ;
		$row['board_default'] = ($context['user']['is_guest']?false:($options['SMFChess_board']==$row['id_chess']?false:true));
		$row['can_delete'] = allowedTo('chess_admin');

		$context['SMFChess']['page'][] = $row;
	}
			
	if(mysql_num_rows($result) == 0)
		$context['SMFChess']['error'] = $txt['SMFChess_errors']['nocurrent'];
			
	mysql_free_result($result);
		
	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}chess
		WHERE status < 3 AND status > 0 " . (!empty($_GET['filter']) ? "AND (white = '{$_GET['filter']}' OR black = '{$_GET['filter']}')" : ""). "", __FILE__, __LINE__);
	list ($totalChess) = mysql_fetch_row($request);
	mysql_free_result($request);

	$context['page_index'] = constructPageIndex($scripturl . '?action=chess;sa=current;sort=' . $context['SMFChess']['sort_by'] . (isset($_GET['asc']) ? ';asc' : ''), $context['SMFChess']['start'], $totalChess, $modSettings['defaultMaxMembers']);
		
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess;sa=current',
		'name' => $txt['SMFChess_labels']['current'],
	); 
	
	$context['html_headers'] .= '
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/SMFChess_current.js"></script>
			<script type="text/javascript">
			<!--
			var	cur_session_id = "'.$context['session_id'].'";
			var loadingUrl = \''.$settings['default_theme_url'].'/SMFChess/images/loading.gif\';
			//-->
			</script>';
	
	$context['SMFChess']['do'] = 'current';
	$context['page_title'] = $txt['SMFChess'].' -'.$txt['SMFChess_labels']['current'];
	$context['sub_template'] = 'current';
}

//Loads the finished page
function SMFChessFinished()
{
	global $db_prefix, $context, $options, $modSettings, $scripturl, $user_info, $txt;

	if(isset($_GET['delete'])&&isset($_GET['sesc'])&&(allowedTo('chess_admin'))){
		$_GET['delete'] = (int) $_GET['delete'];
		checkSession('get');
		db_query("
			DELETE FROM {$db_prefix}chess
			WHERE id_chess = {$_GET['delete']}
			LIMIT 1", __FILE__, __LINE__);
			
		db_query("
			DELETE FROM {$db_prefix}chess_move
			WHERE id_chess = {$_GET['delete']}", __FILE__, __LINE__);
			
		db_query("
			DELETE FROM {$db_prefix}chess_chat
			WHERE id_chess = {$_GET['delete']}", __FILE__, __LINE__);			
	}
		
	if(!isset($_GET['start']))
		$context['SMFChess']['start'] = 0;
	else
		$context['SMFChess']['start'] = (int) $_GET['start'];
		
	$context['SMFChess']['board']['SMFChess_piece'] = empty($options['SMFChess_piece'])? $modSettings['SMFChess_piece']: $options['SMFChess_piece'];
		
	$sort_methods = array(
		'updated' => 'chess.updated',
		'created' => 'chess.created',
		'status' => 'chess.status',
		'moves' => 'chess.move'
	);
		
	if (!isset($_GET['sort']) || !isset($sort_methods[$_GET['sort']])){
		$context['SMFChess']['sort_by'] = 'updated';
		$_GET['sort'] = 'chess.updated';
	}else{
		$context['SMFChess']['sort_by'] = $_GET['sort'];
		$_GET['sort'] = $sort_methods[$_GET['sort']];
	}
		
	$context['SMFChess']['sort_direction'] = isset($_GET['asc']) ? 'up' : 'down';
		
	$result = db_query("
		SELECT chess.id_chess, chess.white, chess.black, chess.status, chess.move, chess.created, chess.updated, chess.extra, chess.variation, mw.realName as whiteName, mb.realName as blackName
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		WHERE chess.status > 2
		ORDER BY {$_GET['sort']} " . (isset($_GET['asc']) ? 'ASC' : 'DESC') . "
		LIMIT {$context['SMFChess']['start']}, {$modSettings['defaultMaxMembers']}", __FILE__, __LINE__);
	
	$context['SMFChess']['page'] = array();
	
	while ($row = mysql_fetch_assoc($result)){
		$row['updated'] = date("d M `y", $row['updated']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));
		$row['turn'] = ($row['status'] == 4  ? '-' : ($row['extra'] == $row['white'] ? $row['whiteName'] : $row['blackName']));
		$row['turnC'] = ($row['status'] == 4  ? '' : ($row['extra'] == $row['black'] ? 'black' : 'white'));
		$row['status'] = State_to_Name($row['status']);
		$row['can_delete'] = allowedTo('chess_admin');
		$context['SMFChess']['page'][] = $row;
	}
			
	if(mysql_num_rows($result) == 0)
		$context['SMFChess']['error'] = "<center>".$txt['SMFChess_errors']['nofinished']."</center>";
				
	mysql_free_result($result);
		
	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}chess
		WHERE status > 2", __FILE__, __LINE__);
	list ($totalChess) = mysql_fetch_row($request);
	mysql_free_result($request);

	$context['page_index'] = constructPageIndex($scripturl . '?action=chess;sa=finished;sort=' . $context['SMFChess']['sort_by'] . (isset($_GET['asc']) ? ';asc' : ''), $context['SMFChess']['start'], $totalChess, $modSettings['defaultMaxMembers']);
			
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess;sa=finished',
		'name' => $txt['SMFChess_labels']['finished'],
	); 
		
	$context['SMFChess']['do'] = 'finished';
	$context['page_title'] = $txt['SMFChess'].' - '.$txt['SMFChess_labels']['finished'];
	$context['sub_template'] = 'finished';
}

//Loads the leaderboard
function SMFChessLeaderboard()
{
	global $db_prefix, $context, $options, $modSettings, $scripturl, $user_info, $txt;
	
	if(!isset($_GET['start']))
		$context['SMFChess']['start'] = 0;
	else
		$context['SMFChess']['start'] = (int) $_GET['start'];
		
	$result = db_query("
		SELECT *
		FROM {$db_prefix}members
		WHERE chess_w > 0 OR chess_d > 0 OR chess_l > 0
		ORDER BY chess_elo DESC, chess_w DESC, chess_d DESC, chess_l DESC
		LIMIT {$context['SMFChess']['start']}, {$modSettings['defaultMaxMembers']}", __FILE__, __LINE__);
	$context['SMFChess']['page'] = array();
	$rank = $context['SMFChess']['start'] + 1;
	while ($row = mysql_fetch_assoc($result)){
		$row['rank'] = $rank;
		$context['SMFChess']['page'][] = $row;
		$rank++;
	}
			
	if(mysql_num_rows($result) == 0)
		$context['SMFChess']['error'] = $txt['SMFChess_errors']['noranked'];
			
	mysql_free_result($result);
	
	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}members
		WHERE chess_w > 0 OR chess_d > 0 OR chess_l > 0", __FILE__, __LINE__);
	list ($totalChess) = mysql_fetch_row($request);
	mysql_free_result($request);

	$context['page_index'] = constructPageIndex($scripturl . '?action=chess;sa=leaderboard;', $context['SMFChess']['start'], $totalChess, $modSettings['defaultMaxMembers']);
		
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess;sa=leaderboard',
		'name' => $txt['SMFChess_labels']['leaderboard'],
	); 
		
	$context['SMFChess']['do'] = 'leaderboard';
	$context['page_title'] = $txt['SMFChess'].' - '.$txt['SMFChess_labels']['leaderboard'];
	$context['sub_template'] = 'leaderboard';
}

//Loads the users Settings Page
function SMFChessSettings()
{
	global $options, $settings, $modSettings, $context, $scripturl, $txt, $sourcedir;

	is_not_guest($txt['SMFChess_errors']['is_not_guest']);
			
	if(isset($_POST['options'])){
		if(!isset($_POST['options']['SMFChess_default']))
			$_POST['options']['SMFChess_default'] = false;
		if(!isset($_POST['options']['SMFChess_pm']))
			$_POST['options']['SMFChess_pm'] = false;
		if(!isset($_POST['options']['SMFChess_quickplay']))
			$_POST['options']['SMFChess_quickplay'] = false;
				
		include_once($sourcedir . '/Profile.php');
		makeThemeChanges($context['user']['id'], $settings['theme_id']);
				
		$options['SMFChess_default'] = $_POST['options']['SMFChess_default'];
		$options['SMFChess_light'] = $_POST['options']['SMFChess_light'];
		$options['SMFChess_dark'] = $_POST['options']['SMFChess_dark'];
		$options['SMFChess_piece'] = $_POST['options']['SMFChess_piece'];
		$options['SMFChess_size'] = $_POST['options']['SMFChess_size'];
		$options['SMFChess_border'] = $_POST['options']['SMFChess_border'];
		$options['SMFChess_text'] = $_POST['options']['SMFChess_text'];
		$options['SMFChess_highlight'] = $_POST['options']['SMFChess_highlight'];
		$options['SMFChess_effect'] = $_POST['options']['SMFChess_effect'];
		$options['SMFChess_pm'] = $_POST['options']['SMFChess_pm'];
		$options['SMFChess_quickplay'] = $_POST['options']['SMFChess_quickplay'];
	}
						
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=chess;sa=settings',
		'name' => $txt['SMFChess_labels']['settings'],
	); 
	
	$context['html_headers'] .= '
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/colorpicker/colorPicker.css" />
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/lib/prototype.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/src/scriptaculous.js?load=effects,slider,builder,dragdrop"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/colorpicker/yahoo.color.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/colorpicker/colorPicker.js"></script>
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/SMFChess_settings.css" />
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/SMFChess_settings.js"></script>
			<script type="text/javascript">
			<!--
			var	cur_session_id = "'.$context['session_id'].'";
			var pieceUrl = \''.$settings['default_theme_url'].'/SMFChess/pieces/\';
			var smfchessUrl = \''.$settings['default_theme_url'].'/SMFChess/\';
			var startcolor = "'.$modSettings['SMFChess_highlight'].'";
			var endcolor = "'.$modSettings['SMFChess_light'].'";
			var currentPiece = "'.$modSettings['SMFChess_piece'].'";
			var currentSize = "'.$modSettings['SMFChess_size'].'";
			var currentEffect = "'.$modSettings['SMFChess_effect'].'";
			//-->
			</script>';
			
	$context['SMFChess']['pieces'] = getPieces('');
	$context['SMFChess']['do'] = 'settings';
	$context['page_title'] = $txt['SMFChess'].' - '.$txt['SMFChess_labels']['settings'];
	$context['sub_template'] = 'settings';
}

//Duration to go for the move clock
function DurationtoString($duration)
{
	global $txt;
	
 	$periods = array (
			$txt['SMFChess_g']['d'] => 86400,
			$txt['SMFChess_g']['h'] => 3600,
			$txt['SMFChess_g']['m'] => 60,
			$txt['SMFChess_g']['s'] => 1);

	foreach($periods as $period => $value){
		$count = floor($duration / $value);
		if($count == 0)
			$values[$period] = '00';
		else{
			if($count < 10)
				$count = '0'.$count;
			$values[$period] = $count;
			$duration = $duration % $value;
		}
	}
	
	if(empty($values))
		$values[''] = 0;

	foreach($values as $key => $value)
		$array[] = $value;

	return implode(':', $array);
}

//Another one? this one is different
function DurationtoString2($duration)
{
	global $txt;
 	$periods = array (
			$txt['SMFChess_g']['days'] => 86400,
			$txt['SMFChess_g']['hours'] => 3600,
			$txt['SMFChess_g']['minutes'] => 60,
			$txt['SMFChess_g']['seconds'] => 1);

	foreach($periods as $period => $value){
		$count = floor($duration / $value);
		if($count == 0)
			continue;
		$values[$period] = $count;
		$duration = $duration % $value;
	}
	
	if(empty($values))
		$values[''] = 0;

	foreach($values as $key => $value)
		$array[] = $value.' '.$key;

	return implode(', ', $array);
}

//Finds whats been captured
function findCaptured($boarddata)
{
	$temp = array(
		'wCap' => array(
			'p' => array('total' => 8, 'name' => 'black_pawn'),		
			'n' => array('total' => 2, 'name' => 'black_knight'),
			'r' => array('total' => 2, 'name' => 'black_rook'),
			'b' => array('total' => 2, 'name' => 'black_bishop'),
			'q' => array('total' => 1, 'name' => 'black_queen'),
			'k' => array('total' => 1, 'name' => 'black_king'),		
		),
		'bCap' => array(
			'P' => array('total' => 8, 'name' => 'white_pawn'),
			'N' => array('total' => 2, 'name' => 'white_knight'),
			'R' => array('total' => 2, 'name' => 'white_rook'),
			'B' => array('total' => 2, 'name' => 'white_bishop'),
			'Q' => array('total' => 1, 'name' => 'white_queen'),
			'K' => array('total' => 1,  'name' => 'white_king'),
		)	
	);

	$boarddata = explode(' ' , $boarddata);
	$boarddata = str_split($boarddata[0]);	

	foreach ($boarddata as $value){
		if(isset($temp['wCap'][$value]))
			$temp['wCap'][$value]['total']--;
		if(isset($temp['bCap'][$value]))
			$temp['bCap'][$value]['total']--;
	}
	
	return $temp;
}

//For those damn php4 users
if(!function_exists('str_split')){
	function str_split($text, $split = 1){
		$array = array();
		for ($i = 0; $i < strlen($text);){
			$array[] = substr($text, $i, $split);
			$i += $split;
		}
		return $array;
	}
}
?>
