<?php

//ChessXml Source File
//ChessXml.php

function ChessXml()
{
	global $db_prefix, $modSettings, $user_info, $txt, $settings, $context;
	global $sourcedir, $func;

	checkSession('get');
	
	loadTemplate('ChessXml');	
	loadLanguage('ChessXml');
		
	if(!isset($_GET['id']))
		$_GET['id'] = 0;
	$_GET['id'] = (int)$_GET['id'];
	
	$context['SMFChessXml'] = array();
	
	$actions = array(
		'update' => 'SMFChessXmlUpdate',
		'save' => 'SMFChessXmlSave',
		'export' => 'SMFChessXmlExport',
		'control' => 'SMFChessXmlControl',
		'userSearch' => 'SMFChessXmlUserSearch',
		'userSearchAdv' => 'SMFChessXmlUserSearchAdv',
		'historyViewer' => 'SMFChessXmlHistoryViewer',
		'saveNotepad' => 'SMFChessXmlSaveNotepad',
		'boardViewer' => 'SMFChessXmlBoardViewer',
		'pieceViewer' => 'SMFChessXmlPieceViewer'
	);
	
	if (!isset($_GET['sa']))
		$action = 'update';
	else
		$action = $_GET['sa'];
	
	if(isset($actions[$action]))
		$actions[$action]();
	else
		SMFChessXmlUpdate();
}

//Gets Game Status
function State_to_Name($i) {

	global $txt;
	
	if(!isset($txt['SMFChess_status'][$i]))
		return $txt['SMFChess_status']['UNK'];
	return $txt['SMFChess_status'][$i];
}

//Manages Control MSGS
function Control_to_Name($i) {
	global $context, $scripturl, $txt;
	switch ($i) {
		case 0	:	return "-";
		case 1	:	return ($context['SMFChessXml']['yours'] ? sprintf($txt['SMFChess_control']['undo1'], $context['SMFChessXml']['otherName']).' <a href="javascript:void(0)" onclick="chessCommand(\'undo\');"><b><u>'.$txt['SMFChess_control']['accept'].'</u></b></a> '.$txt['SMFChess_control']['or'].' <a href="javascript:void(0)" onclick="chessCommand(\'reject\');"><b><u>'.$txt['SMFChess_control']['reject'].'</u></b></a>' : sprintf($txt['SMFChess_control']['undo2'], $context['SMFChessXml']['turnName']));
		case 2	:	return ($context['SMFChessXml']['yours'] ? $txt['SMFChess_control']['notstarted1'] : $txt['SMFChess_control']['notstarted2']);
		case 3	:	return (($context['SMFChessXml']['extra'] == $context['user']['id']) && !empty($context['SMFChessXml']['side']) ? sprintf($txt['SMFChess_control']['draw1'], $context['SMFChessXml']['otherName']).' <a href="javascript:void(0)" onclick="chessCommand(\'draw\');"><b><u>'.$txt['SMFChess_control']['accept'].'</u></b></a> '.$txt['SMFChess_control']['or'].' <a href="javascript:void(0)" onclick="chessCommand(\'reject\');"><b><u>'.$txt['SMFChess_control']['reject'].'</u></b></a>' : sprintf($txt['SMFChess_control']['draw2'], $context['SMFChessXml']['turnName']));
		case 4	:	return (($context['SMFChessXml']['extra'] == $context['user']['id']) && !empty($context['SMFChessXml']['side']) ? sprintf($txt['SMFChess_control']['resign1'], $context['SMFChessXml']['otherName']).' <a href="javascript:void(0)" onclick="chessCommand(\'resign\');"><b><u>'.$txt['SMFChess_control']['accept'].'</u></b></a> '.$txt['SMFChess_control']['or'].' <a href="javascript:void(0)" onclick="chessCommand(\'reject\');"><b><u>'.$txt['SMFChess_control']['reject'].'</u></b></a>' : sprintf($txt['SMFChess_control']['resign2'], $context['SMFChessXml']['turnName']));
		default	:	return $txt['SMFChess_control']['unk'];
	}
} 

//Manages PM's
function chessPM($type, $sendId, $boardId)
{
	global $scripturl, $context, $sourcedir, $db_prefix, $settings, $txt;
	
	$request = db_query("
	SELECT COUNT(*)
	FROM {$db_prefix}themes
	WHERE ID_MEMBER = '{$sendId}' AND variable='SMFChess_pm' AND value='' AND ID_THEME='{$settings['theme_id']}'", __FILE__, __LINE__);
	list ($totalPM) = mysql_fetch_row($request);
	mysql_free_result($request);
	
	$totalPM = in_array($type, array('undo', 'draw', 'resign')) || ($totalPM == 0);
	
	$request = db_query("
		SELECT lo.ID_MEMBER
		FROM {$db_prefix}log_online AS lo
		WHERE lo.url LIKE '%chess%' AND lo.url LIKE '%\"id\";s:%:\"{$boardId}\"%' AND lo.ID_MEMBER = {$sendId} AND (UNIX_TIMESTAMP(lo.logTime) > " . (time() - 20) . ")
		LIMIT 1", __FILE__, __LINE__);
	$isOnline = (mysql_num_rows($request) > 0);
	mysql_free_result($request);
	
	if(($totalPM && (!$isOnline))||preg_match('/admin/', $type))
	{	
		if(in_array($type, array('move', 'admin_move', 'undo', 'draw', 'resign'))){
			include_once($sourcedir . '/Subs-Post.php');
			
			$pmfrom = array(
				'id' => $context['user']['id'],
				'name' => $context['user']['name'],
				'username' => $context['user']['username']
			);
			
			// Who the IM is going to
			$pmto = array(
				'to' => array($sendId),
				'bcc' => array()
			);
			
			// The subject of the message
			$subject = $txt['SMFChess_pm'][$type.'_sub'];
			// The actual message contents
			$message = $txt['SMFChess_pm'][$type.'_msg'].$txt['SMFChess_pm']['followlink'].$scripturl.'?action=chess;id='.$boardId;
			// Now, send!
			sendpm($pmto, $subject, $message, 0, $pmfrom);
		}
	}
}

//Loads Board Info and puts it into an array
function loadBoardInfo(){
		
	global $db_prefix, $modSettings, $user_info, $txt, $settings, $context;
	global $sourcedir, $func;
	
	$_GET['id'] = (int) $_GET['id'];
	
	$result = db_query("
		SELECT chess.*, mw.realName as whiteName, mw.chess_elo as whiteElo, mw.chess_s as whiteStreak, mb.realName as blackName, mb.chess_elo as blackElo, mb.chess_s as blackStreak, cm.boarddata as rookInitial
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		LEFT JOIN {$db_prefix}chess_move AS cm ON ((chess.id_chess = cm.id_chess) AND (cm.move = 1))
		WHERE chess.id_chess = '{$_GET['id']}'
		ORDER BY chess.id_chess
		LIMIT 1
		", __FILE__, __LINE__);
		
	if(mysql_num_rows($result) == 0){
		$context['SMFChessXml']['timestamp'] = 0;
		$context['SMFChessXml']['boarddata'] = '';
		$context['SMFChessXml']['message'] = $txt['SMFChessXml_errors']['nousers'];
		$context['SMFChessXml']['move'] = '';
		$context['SMFChessXml']['turnName'] = '';
		$context['SMFChessXml']['status'] = '';
		$context['SMFChessXml']['updated'] = '';
		$context['SMFChessXml']['history'] = array();
		mysql_free_result($result);
		return false;
	}else{
		$temp = mysql_fetch_assoc($result);
		$context['SMFChessXml'] = $temp;
		$context['SMFChessXml']['timestamp'] = $temp['updated'];
		
		if(strstr($temp['boarddata'], "w")){
			$context['SMFChessXml']['turn'] = $temp['white'];
			$context['SMFChessXml']['turnOther'] = $temp['black'];
			$context['SMFChessXml']['turnName'] = $temp['whiteName'];
			$context['SMFChessXml']['otherName'] = $temp['blackName'];
		}else{
			$context['SMFChessXml']['turn'] = $temp['black'];
			$context['SMFChessXml']['turnOther'] = $temp['white'];
			$context['SMFChessXml']['turnName'] = $temp['blackName'];
			$context['SMFChessXml']['otherName'] = $temp['whiteName'];
		}
			
		if($temp['status'] == 4){
			$context['SMFChessXml']['turnName'] = '-';
		}elseif(($temp['status'] == 5)||($temp['status'] == 3)){
			if($temp['extra'] == $temp['white']){
				$context['SMFChessXml']['turnName'] = $temp['whiteName'];
				$context['SMFChessXml']['turn'] = $temp['white'];
				$context['SMFChessXml']['turnOther'] = $temp['black'];
				$context['SMFChessXml']['otherName'] = $temp['blackName'];
			}else{
				$context['SMFChessXml']['turn'] = $temp['black'];
				$context['SMFChessXml']['turnOther'] = $temp['white'];
				$context['SMFChessXml']['turnName'] = $temp['blackName'];
				$context['SMFChessXml']['otherName'] = $temp['whiteName'];			
			}
		}	

		$context['SMFChessXml']['oppId'] = $context['user']['id'] == $context['SMFChessXml']['turn'] ? $context['SMFChessXml']['turnOther'] : $context['SMFChessXml']['turn'] ;
		$context['SMFChessXml']['oppName'] = $context['user']['id'] == $temp['white'] ? $temp['blackName'] : $temp['whiteName'] ;
		$context['SMFChessXml']['side'] = ($temp['white'] == $context['user']['id'] ? 'w' : ($context['user']['id'] == $temp['black'] ? 'b' : '')); 
		$context['SMFChessXml']['yours'] = (($context['user']['id'] == $context['SMFChessXml']['turn'])&&($temp['status'] < 3));
		$context['SMFChessXml']['turnHeader'] = ($temp['status'] > 2) ? $txt['SMFChessXml']['turnheader_w'].':' : $txt['SMFChessXml']['turnheader_t'].':';
		$context['SMFChessXml']['statusId'] = $temp['status'];
		$context['SMFChessXml']['status'] = State_to_Name($temp['status']);
		$context['SMFChessXml']['extra'] = $temp['extra'];
		
		$context['SMFChessXml']['message'] = '<b>'.Control_to_Name($temp['control']).'</b>';
		
		$context['SMFChessXml']['control'] = $temp['control'];
		
		//Initial Rook Positions
		if(empty($context['SMFChessXml']['rookInitial']))
			$context['SMFChessXml']['rookInitial'] = $context['SMFChessXml']['boarddata'];
		
		$context['SMFChessBoard']['rookInitial'] = array();
		
		$context['SMFChessBoard']['rookInitial']['BQ'] = strpos($context['SMFChessXml']['rookInitial'], 'r');
		$context['SMFChessBoard']['rookInitial']['BK'] = strpos($context['SMFChessXml']['rookInitial'], 'r', $context['SMFChessBoard']['rookInitial']['BQ'] + 1);
		$context['SMFChessBoard']['rookInitial']['WQ'] = 21 + $context['SMFChessBoard']['rookInitial']['BK'];
		$context['SMFChessBoard']['rookInitial']['WK'] = 21 + $context['SMFChessBoard']['rookInitial']['BQ'];
		$context['SMFChessBoard']['rookInitial']['BK'] = 91 + $context['SMFChessBoard']['rookInitial']['BK'];
		$context['SMFChessBoard']['rookInitial']['BQ'] = 91 + $context['SMFChessBoard']['rookInitial']['BQ'];
		
		if($temp['updated'] != 0)
				$context['SMFChessXml']['updated'] = date("d M g:ia", $temp['updated']+(($user_info['time_offset'] + $modSettings['time_offset']) * 3600));	
		else
			$context['SMFChessXml']['updated'] = '-';
		
		//Move Clock
		if($context['SMFChessXml']['moveclock']){
			if(($context['SMFChessXml']['statusId'] == 0)||($context['SMFChessXml']['statusId'] > 2))
				$context['SMFChessXml']['moveTimeleft'] = DurationtoString($context['SMFChessXml']['moveclock']);
			else{
				$context['SMFChessXml']['moveTimeleft'] = $context['SMFChessXml']['moveclock'] - (time() - $context['SMFChessXml']['movetime']);
				$context['SMFChessXml']['moveTimeleft'] = ($context['SMFChessXml']['moveTimeleft'] < 0) ? 0 : $context['SMFChessXml']['moveTimeleft'];
				
				if(($context['SMFChessXml']['moveTimeleft'] == 0) && (!empty($context['SMFChessXml']['side'])) && (!$context['SMFChessXml']['yours']) && (!$context['SMFChessXml']['control'])){
					$context['SMFChessXml']['message'] = '<b>'.$txt['SMFChess_control']['moveexpired'].' '.$txt['SMFChess_control']['click'].' <a href="javascript:void(0)" onclick="if(confirm(\''.$txt['SMFChess_control']['yousure'].'\')){chessCommand(\'clock_accept_win\');}"><u>'.$txt['SMFChess_control']['here'].'</u></a> '.$txt['SMFChess_control']['acceptwin'].'</b>';
				}
				$context['SMFChessXml']['moveTimeleftNum'] = $context['SMFChessXml']['moveTimeleft'];
				$context['SMFChessXml']['moveTimeleft'] = DurationtoString($context['SMFChessXml']['moveTimeleft']);
				
				if($context['SMFChessXml']['moveTimeleftNum'] < 3600)
					$context['SMFChessXml']['moveTimeleft'] = '<span class="meaction">'.$context['SMFChessXml']['moveTimeleft'].'</span>';				
			}
		}else
			$context['SMFChessXml']['moveTimeleft'] = '-';
		
		mysql_free_result($result);
	}
	
	return true;
}

//Update Function, where the magic goes to die
function SMFChessXmlUpdate()
{
	global $context, $db_prefix, $options, $modSettings, $settings, $sourcedir, $txt;
	
	if(loadBoardInfo()){
		if(!isset($_GET['timestamp']))
			$_GET['timestamp'] = 0;
	
		if($context['SMFChessXml']['timestamp'] == $_GET['timestamp'])
			$context['sub_template'] = 'ChessXmlUpdateFailed';
		else{
			//Get captured
			$context['SMFChessXml']['captured'] = findCaptured($context['SMFChessXml']['boarddata']);
			$context['SMFChessXml']['board']['SMFChess_piece'] = empty($options['SMFChess_piece'])? $modSettings['SMFChess_piece']: $options['SMFChess_piece'];
			$context['SMFChessXml']['board']['filetype'] = file_exists($settings['default_theme_dir'].'/SMFChess/pieces/' . $context['SMFChessXml']['board']['SMFChess_piece'] . '/white_pawn.png') ? '.png' : '.gif' ;
			
			//Configure Variations
			if(($context['SMFChessXml']['variation'] == 1)&&($context['SMFChessXml']['statusId'] < 2)){
				include_once($sourcedir . '/ChessFunctions.php');
				set_FEN($context['SMFChessXml']['boarddata']);
				set_darkchess(($context['SMFChessXml']['black'] == $context['user']['id'] ? -1 : ($context['SMFChessXml']['white'] == $context['user']['id'] ? 1 :0)));
				$context['SMFChessXml']['boarddata'] = get_FEN();
			}
			
			//Move History
			$result = db_query("SELECT *
				FROM {$db_prefix}chess_move
				WHERE id_chess = '{$context['SMFChessXml']['id_chess']}'".(($context['SMFChessXml']['variation'] == 1)&&($context['SMFChessXml']['statusId'] < 2) ? " AND id_member = {$context['user']['id']}" : "")."
				ORDER BY id_move DESC
				LIMIT 8
				", __FILE__, __LINE__);
			
			$context['SMFChessXml']['history'] = array();
			$context['SMFChessXml']['history'][] = '<a href="javascript:void(0)" onclick="checkUpdate();">---------</a><br/>';
			while ($row = mysql_fetch_assoc($result)){
				$context['SMFChessXml']['history'][] = '<a href="javascript:void(0)" onclick="historyViewer('.$row['id_move'].');">'.($row['move'] == 0 ? $row['move_info'] : $row['move'].$row['turn'].'.	'.$row['move_info']).'</a><br/>';
			}
			mysql_free_result($result);
				
			$context['sub_template'] = 'ChessXmlUpdate';
		}
	}else{
		$context['SMFChessXml']['timestamp'] = 0;
		$context['SMFChessXml']['message'] = $txt['SMFChessXml']['notfound'];
		$context['SMFChessXml']['moveTimeleft'] = $txt['SMFChessXml']['notfound'];
		$context['sub_template'] = 'ChessXmlUpdateFailed';
	}
}

//Saving those high intensity moves
function SMFChessXmlSave()
{
	global $db_prefix, $sourcedir, $context, $txt;
	
	if(loadBoardInfo()){
		include_once($sourcedir . '/ChessFunctions.php');
		
		$_REQUEST['addMove'] = trim($_REQUEST['addMove']);
		
		if(($context['SMFChessXml']['moveclock'] > 0)&&($context['SMFChessXml']['moveclock'] < 3601)&&($context['SMFChessXml']['statusId'] == 0)){
			$result = db_query("
				SELECT
					lo.ID_MEMBER, lo.logTime, mem.realName, mem.memberName, mem.showOnline,
					mg.onlineColor, mg.ID_GROUP
				FROM {$db_prefix}log_online AS lo
					LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = lo.ID_MEMBER)
					LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = IF(mem.ID_GROUP = 0, mem.ID_POST_GROUP, mem.ID_GROUP))
				WHERE lo.url LIKE '%chess%' AND lo.url LIKE '%\"id\";s:%:\"{$context['SMFChessXml']['id_chess']}\"%' AND (UNIX_TIMESTAMP(lo.logTime) > " . (time() - 20) . ") AND lo.ID_MEMBER = '{$context['SMFChessXml']['oppId']}'
				ORDER BY mem.memberName", __FILE__, __LINE__);
			$unlockBoard = (mysql_num_rows($result) == 1);
			mysql_free_result($result);
			
		}else
			$unlockBoard = true;
		
		if($unlockBoard){
			if((isset($_REQUEST['addMove']))&&($context['SMFChessXml']['yours'])){
				if(set_FEN($context['SMFChessXml']['boarddata'])&&(add_Move($_REQUEST['addMove']))){
					$context['SMFChessXml']['boarddata'] = get_FEN();
					$context['SMFChessXml']['statusId'] = State_to_String(get_GameState());
					$context['SMFChessXml']['move'] = $context['SMFChessBoard']['move'];
					
					//Manage Variations
					if($context['SMFChessXml']['variation'] > 0){
						//DarkChess
						if(($context['SMFChessXml']['variation'] == 1)&&($context['SMFChessXml']['statusId'] > 1)){
							$context['SMFChessXml']['statusId'] = 3;
						//Extinction
						}elseif($context['SMFChessXml']['variation'] == 2){
							if(gt_extinction($context['SMFChessXml']['boarddata']))
								$context['SMFChessXml']['statusId'] = 3;
						}
					}
					
					if($context['SMFChessXml']['statusId'] == 3){
						$context['SMFChessXml']['turn'] = (strstr($context['SMFChessXml']['boarddata'], "w")?$context['SMFChessXml']['black']:$context['SMFChessXml']['white']);
						$context['SMFChessXml']['turnOpp'] = (strstr($context['SMFChessXml']['boarddata'], "w")?$context['SMFChessXml']['white']:$context['SMFChessXml']['black']);
					}elseif($context['SMFChessXml']['statusId'] > 3)
						$context['SMFChessXml']['turn'] = 0;
					else
						$context['SMFChessXml']['turn'] = (strstr($context['SMFChessXml']['boarddata'], "w")?$context['SMFChessXml']['white']:$context['SMFChessXml']['black']);
					
					$context['SMFChessXml']['turnC'] = (strstr($context['SMFChessXml']['boarddata'], "w")?'b':'w');
					$context['SMFChessXml']['message'] = '-';
					$context['SMFChessXml']['timestamp'] = time();
							
					//Update Board
					db_query("UPDATE {$db_prefix}chess
						SET boarddata='{$context['SMFChessXml']['boarddata']}', status='{$context['SMFChessXml']['statusId']}', move='{$context['SMFChessXml']['move']}', updated='{$context['SMFChessXml']['timestamp']}', control='0', extra='{$context['SMFChessXml']['turn']}', movetime='{$context['SMFChessXml']['timestamp']}'
						WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
						LIMIT 1", __FILE__, __LINE__);	
					//Insert Move
					db_query("INSERT INTO {$db_prefix}chess_move SET id_chess='{$context['SMFChessXml']['id_chess']}', ID_MEMBER='{$context['user']['id']}', move='{$context['SMFChessXml']['move']}', status='{$context['SMFChessXml']['statusId']}', move_info='{$context['SMFChessBoard']['pgn_Move']}', boarddata='{$context['SMFChessXml']['boarddata']}', turn='{$context['SMFChessXml']['turnC']}'" , __FILE__, __LINE__);		
					//Update Scores
					if($context['SMFChessXml']['statusId'] > 2){
						if($context['SMFChessXml']['statusId'] == 3){
							if($context['SMFChessXml']['turn'] == $context['SMFChessXml']['white']){
								addChessStats('W');
							}
							else{
								addChessStats('B');
							}
							addMoveLog(sprintf($txt['SMFChessXml_log']['checkmate'], $context['user']['name']));
						}elseif($context['SMFChessXml']['statusId'] == 4){
							addChessStats('D');
							addMoveLog($txt['SMFChessXml_log']['stalemate']);
						}
					}else
						addMoveLog(sprintf($txt['SMFChessXml_log']['moved'], $context['user']['name'], $context['SMFChessBoard']['pgn_Move']));
					
					chessPM('move', $context['SMFChessXml']['oppId'], $context['SMFChessXml']['id_chess']);		
				}else
					$context['SMFChessXml']['message'] = $_REQUEST['addMove'].$txt['SMFChessXml_errors']['illegalmove'];
			}else
				$context['SMFChessXml']['message'] = $txt['SMFChessXml_errors']['notyourmove'];
		}else
				$context['SMFChessXml']['message'] = $txt['SMFChessXml_errors']['bothplayers'];
	}
	$context['sub_template'] = 'ChessXmlSave';
}

//Export to PGN
function SMFChessXmlExport()
{
	global $context, $db_prefix, $user_info;
	
	$result = db_query("
		SELECT chess.id_chess, chess.boarddata, chess.white, chess.black, chess.status, chess.created, chess.extra, chess.variation, mw.realName as whiteName, mb.realName as blackName, cm.boarddata as initialfen
		FROM {$db_prefix}chess AS chess
		JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
		JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
		LEFT JOIN {$db_prefix}chess_move AS cm ON (cm.move = 0 AND chess.id_chess = cm.id_chess)
		WHERE chess.id_chess = '{$_GET['id']}'
		ORDER BY chess.id_chess
		LIMIT 1
		", __FILE__, __LINE__);
			
	if(mysql_num_rows($result) == 0){
		$context['SMFChessXml']['timestamp'] = 0;
		$context['SMFChessXml']['id_chess'] = 0;
		$context['SMFChessXml']['whiteName'] = '';
		$context['SMFChessXml']['blackName'] = '';
		$context['SMFChessXml']['status'] = '';
		$context['SMFChessXml']['FEN'] = '';
		$context['SMFChessXml']['export'] = array();
		mysql_free_result($result);
	}else{
		$temp = mysql_fetch_assoc($result);
		
		if(($temp['variation'] == 1)&&($temp['status'] < 2)){
			$context['SMFChessXml']['timestamp'] = 0;
			$context['SMFChessXml']['id_chess'] = 0;
			$context['SMFChessXml']['whiteName'] = '';
			$context['SMFChessXml']['blackName'] = '';
			$context['SMFChessXml']['status'] = '';
			$context['SMFChessXml']['FEN'] = '';
			$context['SMFChessXml']['export'] = array();
			mysql_free_result($result);
		}else{
			$context['SMFChessXml']['timestamp'] = date("Y.m.d", $temp['created']+($user_info['time_offset']*60*60));
			$context['SMFChessXml']['id_chess'] = $temp['id_chess'];
			$context['SMFChessXml']['whiteName'] = $temp['whiteName'];
			$context['SMFChessXml']['blackName'] = $temp['blackName'];
			$context['SMFChessXml']['FEN'] = empty($temp['initialfen']) ? 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1' : $temp['initialfen'] ;
			
			
			if(($temp['status'] == 3)||($temp['status'] == 5)){
				if($temp['white'] == $temp['extra'])
					$context['SMFChessXml']['status'] = '1-0';
				else
					$context['SMFChessXml']['status'] = '0-1';
			}elseif($temp['status'] == 4)
				$context['SMFChessXml']['status'] = '1/2-1/2';
			else
				$context['SMFChessXml']['status'] = '*';
				
			mysql_free_result($result);
				
			//Move History
			$result = db_query("
				SELECT move, move_info
				FROM {$db_prefix}chess_move
				WHERE id_chess = '{$context['SMFChessXml']['id_chess']}' AND move > 0
				ORDER BY id_move ASC
				", __FILE__, __LINE__);
			
			$context['SMFChessXml']['export'] = array();
			$moveCounter = 0;
			
			while ($row = mysql_fetch_assoc($result)){
				if($moveCounter == $row['move'])
					$context['SMFChessXml']['export'][] = $row['move_info'].' ';
				else{
					$context['SMFChessXml']['export'][] = $row['move'].'.'.$row['move_info'].' ';
					$moveCounter = $row['move'];
				}
			}
			mysql_free_result($result);
		}
	}
	
	$context['sub_template'] = 'ChessXmlExport';
}

//Let manage those controls
function SMFChessXmlControl()
{
	global $context, $db_prefix, $sourcedir, $txt;
	
	$context['SMFChessXml']['message'] = '-';

	if(loadBoardInfo()){
		if($context['SMFChessXml']['statusId'] < 3){
			if(!empty($context['SMFChessXml']['side'])){
				if($_REQUEST['command'] == 'reject'){				
					db_query("UPDATE {$db_prefix}chess
						SET updated='".time()."', control='0', extra='{$context['SMFChessXml']['turn']}'
						WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
						LIMIT 1", __FILE__, __LINE__);
				}elseif($_REQUEST['command'] == 'undo'){
					$result = db_query("
						SELECT *
						FROM {$db_prefix}chess_move
						WHERE id_chess = '{$context['SMFChessXml']['id_chess']}'
						ORDER BY id_move DESC
						LIMIT 2
						", __FILE__, __LINE__);
						
					if(mysql_num_rows($result) < 2){
						mysql_free_result($result);						
					}else{
						$tempMove = mysql_fetch_assoc($result);	
						$tempMove2 = mysql_fetch_assoc($result);
						$tempMove2['turn'] = $context['SMFChessXml']['turnOther'];
						mysql_free_result($result);
	
						if(($context['SMFChessXml']['control'] == 1)&&($context['SMFChessXml']['yours'])){
							db_query("UPDATE {$db_prefix}chess
								SET boarddata='{$tempMove2['boarddata']}', move='{$tempMove2['move']}', status='{$tempMove2['status']}', updated='".time()."', control='0', extra='{$tempMove2['turn']}', movetime='".time()."'
								WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
								AND control='1' 
								LIMIT 1", __FILE__, __LINE__);
							if(db_affected_rows() > 0){
								db_query("DELETE FROM {$db_prefix}chess_move
									WHERE id_move = {$tempMove['id_move']}
									LIMIT 1", __FILE__, __LINE__);	
							}
							addMoveLog(sprintf($txt['SMFChessXml_log']['undo_a'], $context['SMFChessXml']['oppName']));
														
						}elseif(!$context['SMFChessXml']['yours']){
							db_query("UPDATE {$db_prefix}chess
								SET updated='".time()."', control='1'
								WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
								LIMIT 1", __FILE__, __LINE__);	
							
							addMoveLog(sprintf($txt['SMFChessXml_log']['undo_r'], $context['user']['name']));
									
							chessPM('undo', $context['SMFChessXml']['turn'], $_GET['id']);
						}else
							$context['SMFChessXml']['message'] = $txt['SMFChessXml_log']['undo_f'];
					}
				}elseif($_REQUEST['command'] == 'draw'){
					if(($context['SMFChessXml']['control'] == 3)&&($context['user']['id'] == $context['SMFChessXml']['extra'])){
						db_query("UPDATE {$db_prefix}chess
							SET status='4', updated='".time()."', control='0', extra='0'
							WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
							AND control='3'
							LIMIT 1", __FILE__, __LINE__);
						
						addMoveLog($txt['SMFChessXml_log']['stalemate']);
						addChessStats('D');
					}else{
						db_query("UPDATE {$db_prefix}chess
							SET updated='".time()."', control='3', extra='{$context['SMFChessXml']['oppId']}'
							WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
							LIMIT 1", __FILE__, __LINE__);
						addMoveLog(sprintf($txt['SMFChessXml_log']['draw_r'], $context['user']['name']));
						chessPM('draw', $context['SMFChessXml']['oppId'] , $_GET['id']);
					}
				}elseif($_REQUEST['command'] == 'resign'){
					db_query("UPDATE {$db_prefix}chess
						SET status='5', updated='".time()."', control='0', extra='{$context['SMFChessXml']['oppId']}'
						WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
						AND status < '5'
						LIMIT 1", __FILE__, __LINE__);
					
					if($context['SMFChessXml']['oppId'] == $context['SMFChessXml']['white']){
						addChessStats('W');
					}else{
						addChessStats('B');
					}
					addMoveLog(sprintf($txt['SMFChessXml_log']['resign'], $context['SMFChessXml']['oppName']));
					chessPM('resign', $context['SMFChessXml']['oppId'] , $_GET['id']);
				}elseif($_REQUEST['command'] == 'clock_accept_win'){
					if(($context['SMFChessXml']['moveclock'])&&($context['SMFChessXml']['moveTimeleftNum'] == 0)){
						db_query("UPDATE {$db_prefix}chess
							SET status='5', updated='".time()."', movetime='".time()."', control='0', extra='{$context['user']['id']}'
							WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
							AND status < '5'
							LIMIT 1", __FILE__, __LINE__);
						
						if($context['user']['id'] == $context['SMFChessXml']['white'])
							addChessStats('W');
						else
							addChessStats('B');
						addMoveLog(sprintf($txt['SMFChessXml_log']['timeout'], $context['user']['name']));
						$context['SMFChessXml']['message'] = '-';
					}
				}
			}else
				$context['SMFChessXml']['message'] = $txt['SMFChessXml_errors']['noaccess'];
			
			if(allowedTo('chess_admin')){
				
				if(($_REQUEST['command'] == 'admin_addmove')&&(isset($_REQUEST['addMove']))){
					$context['SMFChessXml']['message'] = $_REQUEST['addMove'];
				
					include_once($sourcedir . '/ChessFunctions.php');
					
					$_REQUEST['addMove'] = trim($_REQUEST['addMove']);
					
					if(set_FEN($context['SMFChessXml']['boarddata'])&&(add_Move($_REQUEST['addMove']))){
						$context['SMFChessXml']['boarddata'] = get_FEN();
						$context['SMFChessXml']['statusId'] = State_to_String(get_GameState());
						$context['SMFChessXml']['move'] = $context['SMFChessBoard']['move'];
				
						if($context['SMFChessXml']['statusId'] == 3){
							$context['SMFChessXml']['turn'] = (strstr($context['SMFChessXml']['boarddata'], "w")?$context['SMFChessXml']['black']:$context['SMFChessXml']['white']);
							$context['SMFChessXml']['turnOpp'] = (strstr($context['SMFChessXml']['boarddata'], "w")?$context['SMFChessXml']['white']:$context['SMFChessXml']['black']);
						}elseif($context['SMFChessXml']['statusId'] > 3){
							$context['SMFChessXml']['turn'] = 0;
						}else{
							$context['SMFChessXml']['turn'] = (strstr($context['SMFChessXml']['boarddata'], "w")?$context['SMFChessXml']['white']:$context['SMFChessXml']['black']);
						}
							
						$context['SMFChessXml']['turnC'] = (strstr($context['SMFChessXml']['boarddata'], "w")?'b':'w');
						$context['SMFChessXml']['message'] = '-';
						$context['SMFChessXml']['timestamp'] = time();
							
						//Update Board
						db_query("UPDATE {$db_prefix}chess
							SET boarddata='{$context['SMFChessXml']['boarddata']}', status='{$context['SMFChessXml']['statusId']}', move='{$context['SMFChessXml']['move']}', updated='{$context['SMFChessXml']['timestamp']}', control='0', extra='{$context['SMFChessXml']['turn']}', movetime='{$context['SMFChessXml']['timestamp']}'
							WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
							LIMIT 1", __FILE__, __LINE__);	
						//Insert Move
						db_query("INSERT INTO {$db_prefix}chess_move SET id_chess='{$context['SMFChessXml']['id_chess']}', ID_MEMBER='{$context['user']['id']}', move='{$context['SMFChessXml']['move']}', status='{$context['SMFChessXml']['statusId']}', move_info='{$context['SMFChessBoard']['pgn_Move']}', boarddata='{$context['SMFChessXml']['boarddata']}', turn='{$context['SMFChessXml']['turnC']}'" , __FILE__, __LINE__);		
						//Update Scores
						addMoveLog(sprintf($txt['SMFChessXml_log']['a_moveadd'], $context['user']['name'], $context['SMFChessBoard']['pgn_Move']));
						if($context['SMFChessXml']['statusId'] > 2){
							if($context['SMFChessXml']['statusId'] == 3){
								if($context['SMFChessXml']['turn'] == $context['SMFChessXml']['white']){
									addChessStats('W');
									addMoveLog(sprintf($txt['SMFChessXml_log']['a_checkmate'], $context['user']['name'], $context['SMFChessXml']['whiteName']));
								}else{
									addChessStats('B');
									addMoveLog(sprintf($txt['SMFChessXml_log']['a_checkmate'], $context['user']['name'], $context['SMFChessXml']['blackName']));
								}
								
							}elseif($context['SMFChessXml']['statusId'] == 4)
								addChessStats('D');
								addMoveLog(sprintf($txt['SMFChessXml_log']['a_stalemate'], $context['user']['name']));
						}
							
						chessPM('admin_move', $context['SMFChessXml']['white'], $context['SMFChessXml']['id_chess']);
						chessPM('admin_move', $context['SMFChessXml']['black'], $context['SMFChessXml']['id_chess']);
					}else
						$context['SMFChessXml']['message'] = $_REQUEST['addMove'].$txt['SMFChessXml_errors']['illegalmove'];
				}elseif($_REQUEST['command'] == 'admin_delete'){
					db_query("DELETE FROM {$db_prefix}chess
						WHERE id_chess = {$context['SMFChessXml']['id_chess']}
						LIMIT 1", __FILE__, __LINE__);
					db_query("DELETE FROM {$db_prefix}chess_move
						WHERE id_chess = {$context['SMFChessXml']['id_chess']}", __FILE__, __LINE__);
					db_query("DELETE FROM {$db_prefix}chess_chat
						WHERE id_chess = {$context['SMFChessXml']['id_chess']}", __FILE__, __LINE__);	
						
					$context['SMFChessXml']['message'] = $txt['SMFChessXml']['boarddeleted'];
				}elseif($_REQUEST['command'] == 'admin_win_white'){
					db_query("UPDATE {$db_prefix}chess
						SET status='5', updated='".time()."', control='0', extra='{$context['SMFChessXml']['white']}'
						WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
						LIMIT 1", __FILE__, __LINE__);
					//Update Stats
					addMoveLog(sprintf($txt['SMFChessXml_log']['a_checkmate'], $context['user']['name'], $context['SMFChessXml']['whiteName']));
					addChessStats('W');
				}elseif($_REQUEST['command'] == 'admin_win_black'){
					db_query("UPDATE {$db_prefix}chess
						SET status='5', updated='".time()."', control='0', extra='{$context['SMFChessXml']['black']}'
						WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
						LIMIT 1", __FILE__, __LINE__);
					//Update Stats
					addMoveLog(sprintf($txt['SMFChessXml_log']['a_checkmate'], $context['user']['name'], $context['SMFChessXml']['blackName']));
					addChessStats('B');
				}elseif($_REQUEST['command'] == 'admin_win_draw'){
					db_query("UPDATE {$db_prefix}chess
						SET status='4', updated='".time()."', control='0', extra='0'
						WHERE id_chess='{$context['SMFChessXml']['id_chess']}'
						LIMIT 1", __FILE__, __LINE__);
					//Update Stats
					addMoveLog(sprintf($txt['SMFChessXml_log']['a_stalemate'], $context['user']['name']));
					addChessStats('D');
				}elseif($_REQUEST['command'] == 'admin_clearchat'){
					db_query("DELETE FROM {$db_prefix}chess_chat
						WHERE id_chess = {$context['SMFChessXml']['id_chess']} AND type < 2", __FILE__, __LINE__);
					$context['SMFChessXml']['message'] = $txt['SMFChessXml']['chatcleared'];	
				}
			}
		}
	}
	
	$context['sub_template'] = 'ChessXmlControl';
}

//Old User Search
function SMFChessXmlUserSearch()
{
	global $db_prefix, $context, $txt;
	
	$query = $_REQUEST['userSearch'] == '' ? "= ''" : "LIKE '%" . strtr($_REQUEST['userSearch'], array('_' => '\\_', '%' => '\\%', '*' => '%')) . "%'";
	$request = db_query("
		SELECT mem.ID_MEMBER, mem.memberName, mem.realName
		FROM {$db_prefix}members AS mem
		WHERE realName $query
		AND is_activated = 1".(isset($_GET['includeself'])?"":" AND (ID_MEMBER != '{$context['user']['id']}')")."
		LIMIT 15", __FILE__, __LINE__);

	$context['SMFChessXml']['searchResults'] = array();
	if(mysql_num_rows($request) == 0)
		$context['SMFChessXml']['searchResults'][] = $txt['SMFChessXml_errors']['nousers'];
	else{
		while ($row = mysql_fetch_assoc($request))
			$context['SMFChessXml']['searchResults'][] = '<a href="javascript:void(0)" onclick="selectedChallenger(\''.$row['memberName'].'\')">'.$row['realName'].'</a>';	
	}
	mysql_free_result($request);
		
	$context['sub_template'] = 'ChessXmlUserSearch';
}

//Funky new user search with the little help of scriptaculous
function SMFChessXmlUserSearchAdv()
{
	global $db_prefix, $context, $scripturl, $modSettings, $user_settings;
	
	if (!isset($_GET['inputArea']))
		$inputArea = 'userSearch';
	else
		$inputArea = $_GET['inputArea'];
	$query = $_REQUEST[$inputArea] == '' ? "= ''" : "LIKE '%" . strtr($_REQUEST[$inputArea], array('_' => '\\_', '%' => '\\%', '*' => '%')) . "%'";
	
	$request = db_query("
		SELECT mem.ID_MEMBER, mem.memberName, mem.realName, mem.chess_elo, mem.avatar, IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
		FROM {$db_prefix}members AS mem
		LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
		WHERE mem.realName $query
		AND mem.is_activated = 1".(isset($_GET['includeself'])?"":" AND (mem.ID_MEMBER != '{$context['user']['id']}')")."
		ORDER BY mem.realName ASC
		LIMIT 5", __FILE__, __LINE__);

	$context['SMFChessXml']['searchResults'] = array();
	if(mysql_num_rows($request) == 0)
		$context['SMFChessXml']['searchResults'] = false;
	else{
		while ($row = mysql_fetch_assoc($request)){
			$row += array(
			'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" width="32" height="32" alt="" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" width="32" height="32" alt="" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" width="32" height="32" alt="" border="0" />'),
			'difference' => (($row['chess_elo'] - $user_settings['chess_elo']) > 0 ? '+' : '').($row['chess_elo'] - $user_settings['chess_elo'])
		);
			$context['SMFChessXml']['searchResults'][] = $row;	
		}
	}
	
	mysql_free_result($request);
		
	$context['sub_template'] = 'ChessXmlUserSearchAdv';
}

//History Viewer, very simple
function SMFChessXmlHistoryViewer()
{
	global $context, $db_prefix, $txt, $settings, $modSettings, $options, $sourcedir;

	if($_GET['id'] == 0){
		$context['SMFChessXml'] = array('boarddata' => 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1',
											'status' => 'UNK',
											'realName' => '-',
											'move' => 0,
											'variation' => 0,
											);
	}else{
		$result = db_query("
			SELECT move.*, mem.realName, chess.white, chess.black, chess.status as actualStatus, chess.variation
			FROM {$db_prefix}chess_move as move
			LEFT JOIN {$db_prefix}members as mem ON (mem.ID_MEMBER = move.ID_MEMBER)
			JOIN {$db_prefix}chess as chess ON (chess.id_chess = move.id_chess)
			WHERE id_move = '{$_GET['id']}'
			ORDER BY id_move DESC
			LIMIT 5
			", __FILE__, __LINE__);
			
		if(mysql_num_rows($result) == 0){
			$context['SMFChessXml'] = array('boarddata' => 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1',
											'status' => 'UNK',
											'realName' => '-',
											'move' => 0,
											'variation' => 0,
											);
		}else		
			$context['SMFChessXml'] = mysql_fetch_assoc($result);
		
		mysql_free_result($result);
	}
	
	$context['SMFChessXml']['turnHeader'] = ($context['SMFChessXml']['status'] == 3) ? $txt['SMFChessXml']['turnheader_w'].':' : $txt['SMFChessXml']['turnheader_t'].':' ;
	$context['SMFChessXml']['realName'] = ($context['SMFChessXml']['status'] == 4) ? '-' : $context['SMFChessXml']['realName'];
	$context['SMFChessXml']['status'] = State_to_Name($context['SMFChessXml']['status']);
	
	//Get captured
	$context['SMFChessXml']['captured'] = findCaptured($context['SMFChessXml']['boarddata']);
	$context['SMFChessXml']['board']['SMFChess_piece'] = empty($options['SMFChess_piece'])? $modSettings['SMFChess_piece']: $options['SMFChess_piece'];
	$context['SMFChessXml']['board']['filetype'] = file_exists($settings['default_theme_dir'].'/SMFChess/pieces/' . $context['SMFChessXml']['board']['SMFChess_piece'] . '/white_pawn.png') ? '.png' : '.gif' ;
	
	//Configure Variations	
	if(($context['SMFChessXml']['variation'] == 1)&&($context['SMFChessXml']['actualStatus'] < 2)){
		include_once($sourcedir . '/ChessFunctions.php');
		set_FEN($context['SMFChessXml']['boarddata']);
		set_darkchess(($context['SMFChessXml']['black'] == $context['user']['id'] ? -1 : ($context['SMFChessXml']['white'] == $context['user']['id'] ? 1 :0)));
		$context['SMFChessXml']['boarddata'] = get_FEN();
	}
	
	$context['sub_template'] = 'ChessXmlHistoryViewer';
}

//Notepad Saving, for what its worth
function SMFChessXmlSaveNotepad()
{
	global $context, $db_prefix, $func, $txt;

	$result = db_query("
		SELECT chess.*, chat.text
		FROM {$db_prefix}chess AS chess
		LEFT JOIN {$db_prefix}chess_chat AS chat ON (chat.type = 2 AND chat.id_member = {$context['user']['id']} AND chat.id_chess = chess.id_chess)
		WHERE chess.id_chess = '{$_GET['id']}' AND (chess.white = {$context['user']['id']} OR chess.black = {$context['user']['id']})
		LIMIT 1
		", __FILE__, __LINE__);
		
	if((mysql_num_rows($result) == 0) || !isset($_REQUEST['message'])){
		$context['SMFChessXml']['message'] = $txt['SMFChessXml_errors']['failed'];
		mysql_free_result($result);
	}else{
		$context['SMFChessXml'] = mysql_fetch_assoc($result);
		mysql_free_result($result);
		if(empty($context['SMFChessXml']['text'])){
			//Check if Exists
			$result = db_query("
				SELECT *
				FROM {$db_prefix}chess_chat
				WHERE type = 2 AND id_member = {$context['user']['id']} AND id_chess = '{$context['SMFChessXml']['id_chess']}'
				LIMIT 1
				", __FILE__, __LINE__);
			//Create
			if(mysql_num_rows($result) == 0){
				$context['SMFChessXml']['message'] = 'make';
				db_query("INSERT INTO {$db_prefix}chess_chat 
						SET id_chess='{$context['SMFChessXml']['id_chess']}',  timestamp='".time()."', 
						text='', type='2', id_member='{$context['user']['id']}'" , __FILE__, __LINE__);
			}
			mysql_free_result($result);
		}
		if ($func['htmltrim']($_REQUEST['message']) === '')
			$context['SMFChessXml']['Text'] = '';
		else
			$context['SMFChessXml']['Text'] = $func['htmlspecialchars']($_REQUEST['message'], ENT_QUOTES);
			
		db_query("UPDATE {$db_prefix}chess_chat 
					SET timestamp='".time()."', text='{$context['SMFChessXml']['Text']}'
					WHERE id_chess='{$context['SMFChessXml']['id_chess']}' AND type='2' AND id_member='{$context['user']['id']}'
					LIMIT 1" , __FILE__, __LINE__);
		$context['SMFChessXml']['message'] = 1;
	}
	
	$context['sub_template'] = 'ChessXmlSaveNotepad';
}

//Board Preview, for tooltips
function SMFChessXmlBoardViewer()
{
	global $context, $db_prefix, $settings, $options, $modSettings, $txt;
	
	if(empty($_GET['id'])){
		$context['SMFChessXml'] = array('boardHtml' => $txt['SMFChessXml_errors']['failed']);
	}else{	
	
			$board = (int) $_GET['id'];
	
			$result = db_query("
				SELECT chess.id_chess, chess.boarddata, chess.move, mw.realName as whiteName, mb.realName as blackName
				FROM {$db_prefix}chess AS chess
				JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
				JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
				WHERE chess.id_chess = '{$board}' AND chess.variation != 1
				LIMIT 1
				", __FILE__, __LINE__);
			if(mysql_num_rows($result) == 0){
				mysql_free_result($result);
				$context['SMFChessXml'] = array('boardHtml' => $txt['SMFChessXml_errors']['failed'], 'boardId' => $_GET['id']);
			}else{
				list($boardid, $board, $move, $whiteName, $blackName) = mysql_fetch_row($result);
				mysql_free_result($result);
				
				if($move > 0){
					$result = db_query("
					SELECT move_info
					FROM {$db_prefix}chess_move
					WHERE id_chess = '{$boardid}' AND move = '{$move}'
					ORDER BY id_move
					LIMIT 2
					", __FILE__, __LINE__);
					$moveInfo = $move.'.';
					while ($row = mysql_fetch_assoc($result))
						$moveInfo .= ' '.$row['move_info'];
					mysql_free_result($result);
				}
				$board = explode(' ', $board);
				$board = $board[0];
	
	$context['SMFChessXml']['boardId'] = $_GET['id'];
	
	if(!isset($BoardSettings['SMFChess_dark'])){
		if(!isset($options['SMFChess_light'])){
			$options['SMFChess_default'] = true;
			$options['SMFChess_dark'] = $modSettings['SMFChess_dark'];
			$options['SMFChess_light'] = $modSettings['SMFChess_light'];
			$options['SMFChess_piece'] = '';
			$options['SMFChess_border'] = $modSettings['SMFChess_border'];
			$options['SMFChess_text'] = $modSettings['SMFChess_text'];
			$options['SMFChess_highlight'] = $modSettings['SMFChess_highlight'];
		}
	
		$BoardSettings['SMFChess_dark'] = '#'.($options['SMFChess_default']? $modSettings['SMFChess_dark'] : $options['SMFChess_dark']);
		$BoardSettings['SMFChess_light'] = '#'.($options['SMFChess_default']? $modSettings['SMFChess_light'] : $options['SMFChess_light']);
		$BoardSettings['SMFChess_border'] = '#'.($options['SMFChess_default']? $modSettings['SMFChess_border'] : $options['SMFChess_border']);
		$BoardSettings['SMFChess_piece'] = empty($options['SMFChess_piece'])? $modSettings['SMFChess_piece']: $options['SMFChess_piece'];
		$BoardSettings['SMFChess_text'] = '#'.($options['SMFChess_default']? $modSettings['SMFChess_text'] : $options['SMFChess_text']);
		$BoardSettings['SMFChess_highlight'] = '#'.($options['SMFChess_default']? $modSettings['SMFChess_highlight'] : $options['SMFChess_highlight']);
		$BoardSettings['SMFChess_filetype'] = file_exists($settings['default_theme_dir'].'/SMFChess/pieces/' . $BoardSettings['SMFChess_piece'] . '/white_pawn.png') ? '.png' : '.gif' ;
	}
	$boardTop = '<tr><td bgcolor="'.$BoardSettings['SMFChess_border'].'">&nbsp;</td>';
	if(isset($_GET['blackbelow'])){
		for($a = '104'; $a != '96';$a--){
			$boardTop .= '<td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center">&nbsp;<font color="'.$BoardSettings['SMFChess_text'].'"><b>'.sprintf('%c', $a).'</b></font>&nbsp;</td>';
		}
	}else{
		for($a = 'a'; $a != 'i';$a++){
			$boardTop .= '<td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center">&nbsp;<font color="'.$BoardSettings['SMFChess_text'].'"><b>'.$a.'</b></font>&nbsp;</td>';
		}
	}
	$boardTop .= '<td bgcolor="'.$BoardSettings['SMFChess_border'].'">&nbsp;</td></tr>';
	
	$boardMiddle = '';
			
		
	if(isset($_GET['blackbelow']))
		$board = strrev($board);

	$board = explode('/', $board);
	if(count($board) != 8)
		$context['SMFChessXml'] = array('boardHtml' => $txt['SMFChessXml_errors']['failed'], 'boardId' => $_GET['id']);
	
	$odd = 1;
	$temp = '';
	$colNum = 8;
	$highlight = false;
	$Board = array();
	foreach($board as $row){
	$odd++;
		$board2 = preg_split('//', $row, -1, PREG_SPLIT_NO_EMPTY);
		$boardMiddle .= '<tr><td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center">&nbsp;<font color="'.$BoardSettings['SMFChess_text'].'"><b>'.(isset($_GET['blackbelow'])? 9 - $colNum : $colNum).'</b></font>&nbsp;</td>';
		foreach($board2 as $key => $col){
			$i = 0;
			switch ($col) {
						case "K": $temp = 'white_king'; break;
						case "Q": $temp = 'white_queen'; break;
						case "R": $temp = 'white_rook'; break;
						case "B": $temp = 'white_bishop'; break;
						case "N": $temp = 'white_knight'; break;
						case "P": $temp = 'white_pawn'; break;
						case "k": $temp = 'black_king'; break;
						case "q": $temp = 'black_queen'; break;
						case "r": $temp = 'black_rook'; break;
						case "b": $temp = 'black_bishop'; break;
						case "n": $temp = 'black_knight'; break;
						case "p": $temp = 'black_pawn'; break;

						case "1": $i = 1; break;
						case "2": $i = 2; break;
						case "3": $i = 3; break;
						case "4": $i = 4; break;
						case "5": $i = 5; break;
						case "6": $i = 6; break;
						case "7": $i = 7; break;
						case "8": $i = 8; break;
						
						case "!": break;
						
						default : $context['SMFChessXml'] = array('boardHtml' => $txt['SMFChessXml_errors']['failed'], 'boardId' => $_GET['id']);
			}
			if($col == '!'){
				if(!isset($_GET['blackbelow']))
					$highlight = true;
			}else{
				if(isset($_GET['blackbelow'])){
					if(isset($board2[$key + 1]))
						if($board2[$key + 1] == '!'){
						$highlight = true;
					}
				}
				
				if($i > 0){
					while($i > 0){
						$boardMiddle .= '<td bgcolor="'. ($highlight ? $BoardSettings['SMFChess_highlight'] : ($odd % 2 ? $BoardSettings['SMFChess_dark'] : $BoardSettings['SMFChess_light'] )) .'"><img border="0" src="'.$settings['default_theme_url'].'/SMFChess/pieces/blank'.$BoardSettings['SMFChess_filetype'].'" height="33" width="33"/></td>';
						$i--;
						$odd++;
					}
				}else{
					$boardMiddle .= '<td bgcolor="'. ($highlight ? $BoardSettings['SMFChess_highlight'] : ($odd % 2 ? $BoardSettings['SMFChess_dark'] : $BoardSettings['SMFChess_light'] )) .'"><img border="0" src="'.$settings['default_theme_url'].'/SMFChess/pieces/'.$BoardSettings['SMFChess_piece'].'/'.$temp.$BoardSettings['SMFChess_filetype'].'" height="33" width="33"/></td>';
					$odd++;
				}
				$highlight = false;
			}
				
		}
		$boardMiddle .= '<td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center">&nbsp;<font color="'.$BoardSettings['SMFChess_text'].'"><b>'.(isset($_GET['blackbelow'])? 9 - $colNum : $colNum).'</b></font>&nbsp;</td></tr>';
		$colNum--;
	}

	if(($odd != 73)||($colNum != 0))
		$context['SMFChessXml'] = array('boardHtml' => $txt['SMFChessXml_errors']['failed'], 'boardId' => $_GET['id']);

	$context['SMFChessXml']['boardHtml'] = '<table border="0" cellpadding="0" cellspacing="0"><tbody><tr><td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center" colspan="10"><span class="smalltext" style="color:'.$BoardSettings['SMFChess_text'].';" onclick="tt_HideInit()"><b>'.$txt['SMFChessXml']['close'].'</b></span></td></tr>'.(isset($whiteName)?'<tr><td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center" colspan="10"><font color="'.$BoardSettings['SMFChess_text'].'"><b>'.$whiteName.' '.$txt['SMFChessXml']['vs'].' '.$blackName.'</b></font></td></tr>':'').$boardTop.$boardMiddle.$boardTop.(isset($moveInfo)?'<tr><td bgcolor="'.$BoardSettings['SMFChess_border'].'" align="center" colspan="10"><font color="'.$BoardSettings['SMFChess_text'].'"><b>'.$moveInfo.'</b></font></td></tr>':'').'</tbody></table>';
	
	}
	}
	$context['sub_template'] = 'ChessXmlBoardViewer';
}

//Add a move log
function addMoveLog($text)
{
	global $db_prefix, $context, $func;
	
	if ($func['htmltrim']($text) != ''){
		$text = $func['htmlspecialchars']($text, ENT_QUOTES);
		db_query("INSERT INTO {$db_prefix}chess_chat 
					SET id_chess='{$context['SMFChessXml']['id_chess']}',  timestamp='".time()."', 
					text='{$text}', type=1, id_member='{$context['user']['id']}'" , __FILE__, __LINE__);
	}
}

//Manage Stats
//More Complicated then it needs to be
//More Simple then it should be
function addChessStats($type)
{
	global $context, $db_prefix;
	
	// Calc W
	if($context['SMFChessXml']['whiteElo'] < 1200){
		$eloK = 32;
		$bonus = ($type == 'W') ? 400 : -400 ;
	}elseif($context['SMFChessXml']['whiteElo'] < 1400){
		$eloK = 16;
		$bonus = ($type == 'W') ? 100 : -100 ;
	}elseif($context['SMFChessXml']['whiteElo'] < 1600){
		$eloK = 16;
		$bonus = 0 ;
	}else{
		$eloK = 8;
		$bonus = 0 ;
	}

	$result = ($type == 'W') ? 1 : (($type == 'D') ? .5 : 0 ) ;
	
	$newElo = 1 / (1 + (pow(10,((($context['SMFChessXml']['blackElo'] + $bonus) - $context['SMFChessXml']['whiteElo'])/400))));
	
	$newElo = (int) ($context['SMFChessXml']['whiteElo'] + ($eloK * ($result - $newElo)));
	
	$newElo = ($newElo < 1000) ? 1000 : $newElo ;
	
	if(($context['SMFChessXml']['whiteElo'] < 1100) && ($context['SMFChessXml']['whiteElo'] > $newElo))
		$newElo = $context['SMFChessXml']['whiteElo'] ;
	if($result == 1)
		$newArray = array('chess_w' => '+', 'chess_elo' => $newElo, 'chess_s' => (($context['SMFChessXml']['whiteStreak'] >= 0) ? $context['SMFChessXml']['whiteStreak'] + 1 : 1 ));
	elseif($result == .5)
		$newArray = array('chess_d' => '+', 'chess_elo' => $newElo, 'chess_s' => 0);
	else
		$newArray = array('chess_l' => '+', 'chess_elo' => $newElo, 'chess_s' => (($context['SMFChessXml']['whiteStreak'] <= 0) ? $context['SMFChessXml']['whiteStreak'] - 1 : -1 ));
	
	updateMemberData($context['SMFChessXml']['white'], $newArray);

	// Calc B
	if($context['SMFChessXml']['blackElo'] < 1200){
		$eloK = 32;
		$bonus = ($type == 'B') ? 400 : -400 ;
	}elseif($row['blackElo'] < 1400){
		$eloK = 16;
		$bonus = ($type == 'B') ? 100 : -100 ;
	}elseif($context['SMFChessXml']['blackElo'] < 1600){
		$eloK = 16;
		$bonus = 0 ;
	}else{
		$eloK = 8;
		$bonus = 0 ;
	}
	
	$result = ($type == 'B') ? 1 : (($type == 'D') ? .5 : 0 ) ;

	$newElo = 1 / (1 + (pow(10,((($context['SMFChessXml']['whiteElo'] + $bonus) - $context['SMFChessXml']['blackElo'])/400))));
	$newElo = (int) ($context['SMFChessXml']['blackElo'] + ($eloK * ($result - $newElo)));
	
	$newElo = ($newElo < 1000) ? 1000 : $newElo ;
	
	if(($context['SMFChessXml']['blackElo'] < 1100) && ($context['SMFChessXml']['blackElo'] > $newElo))
		$newElo = $context['SMFChessXml']['blackElo'] ;
	
	if($result == 1)
		$newArray = array('chess_w' => '+', 'chess_elo' => $newElo, 'chess_s' => (($context['SMFChessXml']['blackStreak'] >= 0) ? $context['SMFChessXml']['blackStreak'] + 1 : 1 ));
	elseif($result == .5)
		$newArray = array('chess_d' => '+', 'chess_elo' => $newElo, 'chess_s' => 0);
	else
		$newArray = array('chess_l' => '+', 'chess_elo' => $newElo, 'chess_s' => (($context['SMFChessXml']['blackStreak'] <= 0) ? $context['SMFChessXml']['blackStreak'] - 1 : -1 ));
	
	
	updateMemberData($context['SMFChessXml']['black'], $newArray);
}

//Piece Previewer
//Pretty cool, was mostly messing around with randomness
function SMFChessXmlPieceViewer()
{
	global $context, $settings, $modSettings, $txt;

	if(isset($_GET['getpiece'])){
		if(is_dir($settings['default_theme_dir'].'/SMFChess/pieces/' . $_GET['getpiece'])){
			if(file_exists($settings['default_theme_dir'].'/SMFChess/pieces/' . $_GET['getpiece'] . '/Info.txt'))
				$context['SMFChessXml']['infoContents'] = htmlspecialchars(trim(file_get_contents($settings['default_theme_dir'].'/SMFChess/pieces/' . $_GET['getpiece'] . '/Info.txt'), "\n\r"));
			else
				$context['SMFChessXml']['infoContents'] = '[b]'.$_GET['getpiece'].'[/b]';
			
			//Get Image Type
			if(file_exists($settings['default_theme_dir'].'/SMFChess/pieces/' . $_GET['getpiece'] . '/white_pawn.png'))
				$fileType = '.png';
			else
				$fileType = '.gif';
			
			$context['SMFChessXml']['infoContents'] = parse_bbc($context['SMFChessXml']['infoContents']);
			
			//Recommended Colours Start
			$temp = preg_replace('/[\.\D\S\W]*\[chesscolours]/i','',$context['SMFChessXml']['infoContents']);
			if(!empty($temp)){
				$temp = preg_replace('/\[\/chesscolours][\.\D\S\W]*/','', $temp);
				$temp = explode(',', $temp);
				$temp2 = '<span><span onclick="suggestColor('.sizeof($temp).');">';
				foreach($temp as $key => $i){
					$temp2 .= '<span style="border: thin dotted #000000;color:#'.$i.';background-color: #'.$i.';" id="SC_'.$key.'" title="'.$i.'">--</span> ';
				}
				$temp2 .= '</span><br /><span class="smalltext" >'.$txt['SMFChessXml']['coloursuggest'].'</span></span>';
				$context['SMFChessXml']['infoContents'] = preg_replace('/\[chesscolours]([^>]*)\[\/chesscolours]/i', $temp2, $context['SMFChessXml']['infoContents']);
			}
			//Recommended Colours End
			
			//Add Preview Image
			$context['SMFChessXml']['infoContents'] = '<img name="prevPiece" src="'.$settings['default_theme_url'].'/SMFChess/pieces/'.$_GET['getpiece'].'/black_pawn'.$fileType.'" alt="prevPiece" title="prevPiece" class="previmage" id="previmage" '.($modSettings['SMFChess_size'] ? 'heigh="'.$modSettings['SMFChess_size'].'" width="'.$modSettings['SMFChess_size'].'" ' : '').'/>'.$context['SMFChessXml']['infoContents'];
			$context['SMFChessXml']['imageInfo'] = getimagesize($settings['default_theme_dir'].'/SMFChess/pieces/' . $_GET['getpiece'] . '/white_pawn'.$fileType);
			
		}else
			$context['SMFChessXml']['infoContents'] = '?';
	}else
		$context['SMFChessXml']['infoContents'] = '';

	$context['sub_template'] = 'ChessXmlPieceViewer';
}

//Duration to string, so we know how much time is left to move
function DurationtoString($duration)
{
 	$periods = array (
			'd' => 86400,
			'h' => 3600,
			'm' => 60,
			's' => 1);

	foreach($periods as $period => $value){
		$count = floor($duration / $value);
		if($count == 0)
			$values[$period] = '00';
		else{
			if($count < 10)
				$count = '0'.$count;
			$values[$period] = $count;
			$duration = $duration % $value;
		}
	}
	
	if(empty($values))
		$values[''] = 0;

	foreach($values as $key => $value)
		$array[] = $value;

	return implode(':', $array);
}

//Find captured, returns captured pieces
function findCaptured($boarddata)
{
	$temp = array(
		'wCap' => array(
			'p' => array('total' => 8, 'name' => 'black_pawn'),		
			'n' => array('total' => 2, 'name' => 'black_knight'),
			'r' => array('total' => 2, 'name' => 'black_rook'),
			'b' => array('total' => 2, 'name' => 'black_bishop'),
			'q' => array('total' => 1, 'name' => 'black_queen'),
			'k' => array('total' => 1, 'name' => 'black_king'),		
		),
		'bCap' => array(
			'P' => array('total' => 8, 'name' => 'white_pawn'),
			'N' => array('total' => 2, 'name' => 'white_knight'),
			'R' => array('total' => 2, 'name' => 'white_rook'),
			'B' => array('total' => 2, 'name' => 'white_bishop'),
			'Q' => array('total' => 1, 'name' => 'white_queen'),
			'K' => array('total' => 1,  'name' => 'white_king'),
		)	
	);

	$boarddata = explode(' ' , $boarddata);
	$boarddata = str_split($boarddata[0]);	

	foreach ($boarddata as $value){
		if(isset($temp['wCap'][$value]))
			$temp['wCap'][$value]['total']--;
		if(isset($temp['bCap'][$value]))
			$temp['bCap'][$value]['total']--;
	}
	
	return $temp;
}

//Used in extinction matches
function gt_extinction($boarddata)
{
	$temp = array(
		'P' => array('total' => 0, 'side' => 'b'),
		'p' => array('total' => 0, 'side' => 'w'),		
		'N' => array('total' => 0, 'side' => 'b'),
		'n' => array('total' => 0, 'side' => 'w'),
		'R' => array('total' => 0, 'side' => 'b'),
		'r' => array('total' => 0, 'side' => 'w'),
		'B' => array('total' => 0, 'side' => 'b'),
		'b' => array('total' => 0, 'side' => 'w'),
		'Q' => array('total' => 0, 'side' => 'b'),
		'q' => array('total' => 0, 'side' => 'w'),
		'K' => array('total' => 0, 'side' => 'b'),
		'k' => array('total' => 0, 'side' => 'w'),		
	);

	$boarddata = explode(' ' , $boarddata);
	$boarddata = str_split($boarddata[0]);	

	foreach ($boarddata as $value){
		if(isset($temp[$value]))
			$temp[$value]['total']++;
	}
	
	foreach ($temp as $value){
		if($value['total'] == 0)
			return true;
	}
	
	return false;
}

//Only php5 function made for php4
if(!function_exists('str_split')){
	function str_split($text, $split = 1){
		$array = array();
		for ($i = 0; $i < strlen($text);){
			$array[] = substr($text, $i, $split);
			$i += $split;
		}
		return $array;
	}
}
?>