<?php
//SMFChess Xml template
//ChessXml.template.php

//Update Board Template
function template_ChessXmlUpdate()
{
	global $context, $settings, $options, $txt, $user_info;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<timestamp>'.$context['SMFChessXml']['timestamp'].'</timestamp>
	<boarddata><![CDATA['.$context['SMFChessXml']['boarddata'].']]></boarddata>
	<control><![CDATA['.$context['SMFChessXml']['message'].']]></control>
	<turnname><![CDATA['.($context['SMFChessXml']['yours'] ? '<span class="meaction">'.$txt['SMFChessXml']['yours'].'</span>' : $context['SMFChessXml']['turnName']).']]></turnname>
	<turnheader><![CDATA['.$context['SMFChessXml']['turnHeader'].']]></turnheader>
	<status><![CDATA['.$context['SMFChessXml']['status'].']]></status>
	<updated><![CDATA['.$context['SMFChessXml']['updated'].']]></updated>
	<moveTimeleft><![CDATA['.$context['SMFChessXml']['moveTimeleft'].']]></moveTimeleft>
	<history><![CDATA[';
	
	foreach($context['SMFChessXml']['history'] as $row){
		echo $row.'
		';
	}
	echo ']]></history>
	<capturedw><![CDATA[';
	
	foreach($context['SMFChessXml']['captured']['wCap'] as $k){
		if($k['total'] > 0)
			echo ($k['total'] > 1?$k['total'].'x' : '').'<img src="'.$settings['default_theme_url'].'/SMFChess/pieces/'.$context['SMFChessXml']['board']['SMFChess_piece'].'/'.$k['name'].$context['SMFChessXml']['board']['filetype'].'" alt="'.$k['name'].'" width="30"/>
			';
	}
	echo ']]></capturedw>
	<capturedb><![CDATA[';
	
	foreach($context['SMFChessXml']['captured']['bCap'] as $k){
		if($k['total'] > 0)
			echo ($k['total'] > 1?$k['total'].'x' : '').'<img src="'.$settings['default_theme_url'].'/SMFChess/pieces/'.$context['SMFChessXml']['board']['SMFChess_piece'].'/'.$k['name'].$context['SMFChessXml']['board']['filetype'].'" alt="'.$k['name'].'" width="30"/>
			';
	}
	echo ']]></capturedb>
</smfchess>';
}

//Update Failed Template, used if nothing really to update
function template_ChessXmlUpdateFailed()
{
	global $context, $settings, $options, $txt, $user_info;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<timestamp>'.$context['SMFChessXml']['timestamp'].'</timestamp>
	<moveTimeleft><![CDATA['.$context['SMFChessXml']['moveTimeleft'].']]></moveTimeleft>
	<control><![CDATA['.$context['SMFChessXml']['message'].']]></control>
</smfchess>';
}

//After a save attempt template
function template_ChessXmlSave()
{
	global $context, $settings, $options, $txt;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<control><![CDATA['.$context['SMFChessXml']['message'].']]></control>
</smfchess>';
}

//Export PGN template
function template_ChessXmlExport()
{
	global $context, $settings, $options, $txt;
	Header('Content-disposition: attachment; filename=SMFChess_game#'.$context['SMFChessXml']['id_chess'].'_'.$context['SMFChessXml']['whiteName'].'VS'.$context['SMFChessXml']['blackName'].'.pgn');
	Header('Content-type: application/x-chess-pgn');
	
	echo '[Site "'.$context['forum_name'].'"]
[Date "'.$context['SMFChessXml']['timestamp'].'"]
[Round "0"]
[White "'.$context['SMFChessXml']['whiteName'].'"]
[Black "'.$context['SMFChessXml']['blackName'].'"]
[Result "'.$context['SMFChessXml']['status'].'"]
[Board "'.$context['SMFChessXml']['id_chess'].'"]
[FEN "'.$context['SMFChessXml']['FEN'].'"]

';
	foreach($context['SMFChessXml']['export'] as $row){
		echo $row;
	}
	echo $context['SMFChessXml']['status'];
}

//Control Template
function template_ChessXmlControl()
{
	global $context, $settings, $options, $txt;
	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<control><![CDATA['.$context['SMFChessXml']['message'].']]></control>
</smfchess>';
}

//Old User Search
function template_ChessXmlUserSearch()
{
	global $context, $settings, $options, $txt;
	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<searchResults><![CDATA[';
	$temp = '';
	foreach($context['SMFChessXml']['searchResults'] as $row){
		$temp .= $row.', ';
	}
	echo substr($temp, 0, -2);

	echo ']]></searchResults>
</smfchess>';
}

//Funky User Search using scriptaculous
function template_ChessXmlUserSearchAdv()
{
	global $context, $settings, $options, $txt;

	echo '<ul class="contacts">
		';
	if($context['SMFChessXml']['searchResults']){
		foreach($context['SMFChessXml']['searchResults'] as $row){
			echo '<li class="contact" id="'.$row['ID_MEMBER'].'"><div class="image">'.$row['image'].'</div><div class="name">'.$row['realName'].'</div><div class="email"><span class="informal">'.$txt['SMFChessXml']['elo'].': '.$row['chess_elo'].' ('.$row['difference'].')</span></div><span class="memberName" style="display:none">'.$row['memberName'].'</span></li>';
		}
	}else
		echo $txt['SMFChessXml_errors']['nousers'];
		
	echo '</ul>';
}

//History Viewer, similar to board update
function template_ChessXmlHistoryViewer()
{
	global $context, $settings;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<boarddata><![CDATA['.$context['SMFChessXml']['boarddata'].']]></boarddata>
	<status>'.$context['SMFChessXml']['status'].'</status>
	<turnname><![CDATA['.$context['SMFChessXml']['realName'].']]></turnname>
	<turnheader><![CDATA['.$context['SMFChessXml']['turnHeader'].']]></turnheader>
	<capturedw><![CDATA[';
	
	foreach($context['SMFChessXml']['captured']['wCap'] as $k){
		if($k['total'] > 0)
			echo ($k['total'] > 1?$k['total'].'x' : '').'<img src="'.$settings['default_theme_url'].'/SMFChess/pieces/'.$context['SMFChessXml']['board']['SMFChess_piece'].'/'.$k['name'].$context['SMFChessXml']['board']['filetype'].'" alt="'.$k['name'].'" width="30"/>
			';
	}
	echo ']]></capturedw>
	<capturedb><![CDATA[';
	
	foreach($context['SMFChessXml']['captured']['bCap'] as $k){
		if($k['total'] > 0)
			echo ($k['total'] > 1?$k['total'].'x' : '').'<img src="'.$settings['default_theme_url'].'/SMFChess/pieces/'.$context['SMFChessXml']['board']['SMFChess_piece'].'/'.$k['name'].$context['SMFChessXml']['board']['filetype'].'" alt="'.$k['name'].'" width="30"/>
			';
	}
	echo ']]></capturedb>
</smfchess>';
}

//Note pad save
function template_ChessXmlSaveNotepad()
{
	global $context;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<msg><![CDATA['.$context['SMFChessXml']['message'].']]></msg>
</smfchess>';
}

//Board Preview, link to use is on current page
function template_ChessXmlBoardViewer()
{
	global $context;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<boardid><![CDATA['.$context['SMFChessXml']['boardId'].']]></boardid>
	<boardhtml><![CDATA['.$context['SMFChessXml']['boardHtml'].']]></boardhtml>
</smfchess>';
}

//Piece Previewer
function template_ChessXmlPieceViewer()
{
	global $context, $modSettings;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smfchess>
	<info><![CDATA['.$context['SMFChessXml']['infoContents'].']]></info>
	<imagesize>'.$context['SMFChessXml']['imageInfo'][0].'</imagesize>
</smfchess>';
}

?>