<?php
// SMFChess Install Script


if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

echo 'Instaling/Updating SMFChess Mysql Tables<br />
Adding '.$db_prefix.'chess table if not already created....<br />
';
// Chess Table
db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}chess (
		`id_chess` INT UNSIGNED NOT NULL AUTO_INCREMENT,
		`boarddata` TEXT NOT NULL,
		`white` INT UNSIGNED DEFAULT '0' NOT NULL,
		`black` INT UNSIGNED DEFAULT '0' NOT NULL,
		`status` INT UNSIGNED DEFAULT '0' NOT NULL,
		`move` INT UNSIGNED DEFAULT '0' NOT NULL,
		`created` INT UNSIGNED DEFAULT '0' NOT NULL,
		`updated` INT UNSIGNED DEFAULT '0' NOT NULL,
		`control` INT UNSIGNED DEFAULT '0' NOT NULL,
		`extra` INT UNSIGNED DEFAULT '0' NOT NULL,
		`variation` INT UNSIGNED DEFAULT '0' NOT NULL,
		`moveclock` INT UNSIGNED DEFAULT '0' NOT NULL,
		`movetime` INT UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY (`id_chess`)
	)", __FILE__, __LINE__);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess LIKE 'control'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}chess ADD `control` INT UNSIGNED DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo 'Adding \'control\' to '.$db_prefix.'chess table<br />
';
}
mysql_free_result($result);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess LIKE 'extra'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}chess ADD `extra` INT UNSIGNED DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo 'Adding \'extra\' to '.$db_prefix.'chess table<br />
';
}
mysql_free_result($result);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess LIKE 'variation'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}chess ADD `variation` INT UNSIGNED DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo 'Adding \'variation\' to '.$db_prefix.'chess table<br />
';
}
mysql_free_result($result);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess LIKE 'movetime'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}chess
				ADD `moveclock` INT UNSIGNED DEFAULT '0' NOT NULL,
				ADD `movetime` INT UNSIGNED DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo 'Adding \'moveclock\' and\'movetime\' to '.$db_prefix.'chess table<br />
';
}
mysql_free_result($result);

echo '<br />Adding '.$db_prefix.'chess_move table if not already created....<br />
';
// Chess History Table
db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}chess_move (
		`id_move` INT UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_chess`  INT UNSIGNED DEFAULT '0' NOT NULL,
		`id_member` INT UNSIGNED DEFAULT '0' NOT NULL,
		`move` INT UNSIGNED DEFAULT '0' NOT NULL,
		`status` INT UNSIGNED DEFAULT '0' NOT NULL,
		`move_info` TEXT NOT NULL,
		`boarddata` TEXT NOT NULL,
		`turn` TEXT NOT NULL,
		PRIMARY KEY (`id_move`)
	)", __FILE__, __LINE__);

echo '<br />Adding '.$db_prefix.'chess_chat table if not already created....<br />
';
// Chess Chat Table
db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}chess_chat (
		`id_chat` INT UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_chess`  INT UNSIGNED DEFAULT '0' NOT NULL,
		`timestamp`  INT UNSIGNED DEFAULT '0' NOT NULL,
		`text` TEXT NOT NULL,
		`type`  INT UNSIGNED DEFAULT '0' NOT NULL,
		`id_member` INT UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY (`id_chat`)
	)", __FILE__, __LINE__);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess_chat LIKE 'type'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}chess_chat ADD `type` INT UNSIGNED DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo 'Adding \'type\' to '.$db_prefix.'chess_chat table<br />
';
}
mysql_free_result($result);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess_chat LIKE 'id_member'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}chess_chat ADD `id_member` INT UNSIGNED DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo 'Adding \'id_member\' to '.$db_prefix.'chess_chat table<br />
';
}
mysql_free_result($result);

//Convert Chat Table to UTF-8
//db_query("
//	ALTER TABLE {$db_prefix}chess_chat  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci", __FILE__, __LINE__);
//db_query("
//	ALTER TABLE {$db_prefix}chess_chat CHANGE text text TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ", __FILE__, __LINE__);	

echo '<br />Inserting SMFChess modSettings into '.$db_prefix.'settings if not already....<br />
';
// Settings used in $modSettings array
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_piece', 'classic')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_light', 'F8E1B8')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_dark', 'AE823E')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_size', '0')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_cremind', '4')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_ccancel', '7')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_cquicklimit', '1')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_cjoinlimit', '1')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_border', 'D5D5D5')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_text', '000000')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_highlight', 'FF0000')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_effect', '2')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_bar', '1')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_update', '10')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_timeout', '30')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChess_news', '[b]Welcome to SMFChess Admin Area[/b]
[center][Insert Message Here][/center]')", __FILE__, __LINE__);

db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChessChat_update', '10')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChessChat_timeout', '30')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChessChat_enabled', 'on')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChessChat_see', '0')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChessChat_who', '2')", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('SMFChessChat_log', '2')", __FILE__, __LINE__);



//Add columns to members tables
$result = db_query("SHOW COLUMNS FROM {$db_prefix}members LIKE 'chessW'", __FILE__, __LINE__);
if (mysql_num_rows($result) > 0){
	db_query("ALTER TABLE {$db_prefix}members
				DROP `chessW`,
				DROP `chessD`,
				DROP `chessL`", __FILE__, __LINE__);
	echo '<br />Droping 3 old SMFChess columns from'.$db_prefix.'members<br />
';
}
mysql_free_result($result);



$result = db_query("SHOW COLUMNS FROM {$db_prefix}members LIKE 'chessElo'", __FILE__, __LINE__);
if (mysql_num_rows($result) > 0) {
	db_query("ALTER TABLE {$db_prefix}members
				DROP `chessElo`,
				DROP `chessS`", __FILE__, __LINE__);
	echo '<br />Droping 2 old SMFChess columns from'.$db_prefix.'members<br />
';
}
mysql_free_result($result);

$result = db_query("SHOW COLUMNS FROM {$db_prefix}members LIKE 'chess_w'", __FILE__, __LINE__);
if (mysql_num_rows($result) == 0){
	db_query("ALTER TABLE {$db_prefix}members
				ADD `chess_w` INT UNSIGNED DEFAULT '0' NOT NULL,
				ADD `chess_d` INT UNSIGNED DEFAULT '0' NOT NULL,
				ADD `chess_l` INT UNSIGNED DEFAULT '0' NOT NULL,
				ADD `chess_elo` INT UNSIGNED DEFAULT '1000' NOT NULL,
				ADD `chess_s` TINYINT DEFAULT '0' NOT NULL", __FILE__, __LINE__);
	echo '<br />Inserting 5 columns into'.$db_prefix.'members<br />
';
}
mysql_free_result($result);

//Move to Lower Base
$result = db_query("SHOW COLUMNS FROM {$db_prefix}chess_move LIKE 'moveInfo'", __FILE__, __LINE__);
if (mysql_num_rows($result) > 0){
	db_query("ALTER TABLE {$db_prefix}chess
				CHANGE `ID_CHESS` `id_chess` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT", __FILE__, __LINE__);
	db_query("ALTER TABLE {$db_prefix}chess_chat
				CHANGE `ID_CHAT` `id_chat` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
				CHANGE `ID_CHESS` `id_chess` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'", __FILE__, __LINE__);
	db_query("ALTER TABLE {$db_prefix}chess_move
				CHANGE `ID_MOVE` `id_move` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
				CHANGE `ID_CHESS` `id_chess` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0',
				CHANGE `ID_MEMBER` `id_member` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0',
				CHANGE `moveInfo` `move_info` TEXT,
				CHANGE `memberName` `turn` TEXT", __FILE__, __LINE__);
	echo '<br />Preparing SMFChess tables for SMF2...<br />
';
}
mysql_free_result($result);

echo '<br />Done. SMFChess Tables are now up to date<br />
';
?>
